package com.up.mls.common;

import java.io.Serializable;

import lombok.Data;

@Data
public class Result implements Serializable {

   private static final long serialVersionUID = -3948389268046368059L;

   private Integer code;

   private String message;
   
   private Object content;
   
   private Object data;

   public Result() {}

   public Result(Integer code, String message) {
       this.code = code;
       this.message = message;
   }

   public static Result success() {
       Result result = new Result();
       result.setResultCode(ResultCode.SUCCESS);
       return result;
   }

   public static Result success(Object data) {
       Result result = new Result();
       result.setResultCode(ResultCode.SUCCESS);
       result.setContent(data);
       return result;
   }
   
   public static Result successData(Object data) {
       Result result = new Result();
       result.setResultCode(ResultCode.SUCCESS);
       result.setData(data);
       return result;
   }

   public static Result failure(ResultCode resultCode) {
       Result result = new Result();
       result.setResultCode(resultCode);
       return result;
   }

   public static Result failure(ResultCode resultCode, Object data) {
       Result result = new Result();
       result.setResultCode(resultCode);
       result.setContent(data);
       return result;
   }

   public void setResultCode(ResultCode code) {
       this.code = code.code();
       this.message = code.message();
   }
}
