package com.up.mls.common.constant;

public enum RedisBusinesKeys {

	/**
	 * 租铺宝APP独家实勘商铺
	 */
	MLS_APP_SHOP_DJSKSP("MLS:app:shop:djsksp"),

	/**
	 * 租铺宝APP首页
	 */
	MLS_APP_TOP("MLS:app:top"),

	/**
	 * 租铺宝区域的商圈
	 */
	MLS_BUSINESS_BY_AREAID("MLS:businessArea:byAreaId"),

	/**
	 * 租铺宝商铺编号
	 */
	MLS_SHOP_SHOPNUMBER("MLS:shop:shopNumber"),
	
	/**
	 * 写字楼编号
	 */
	MLS_OFFICE_OFFICENUMBER("MLS:office:officeNumber"),

	/**
	 * 租铺宝商铺浏览量
	 */
	MLS_SHOP_PAGE_VIEW("MLS:shop:pageView:byShopId"),

	/**
	 * 租铺宝24小时商铺
	 */
	MLS_APP_SHOP_COUNT_BY_24_NEW("MLS:app:shop:count:by24New"),

	/**
	 * 租铺宝在线商铺
	 */
	MLS_APP_SHOP_COUNT_BY_ON_LINE("MLS:app:shop:count:byOnLine"),

	/**
	 * 租铺宝正在找铺
	 */
	MLS_APP_SHOP_COUNT_BY_FIND("MLS:app:shop:count:byFind");

	private String prefix;

	RedisBusinesKeys(String prefix) {
		this.prefix = prefix;
	}

	public String getPrefix() {
		return prefix;
	}

	public String join(Object... args) {
		StringBuilder sb = new StringBuilder(prefix);
		for (Object arg : args) {
			sb.append(":").append(arg);
		}
		return sb.toString();
	}

}
