package com.up.mls.config;

import java.io.IOException;
import java.util.Map;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;

import lombok.extern.slf4j.Slf4j;

/**
 * JSON工具类
 * 
 * @author geeks
 *
 */
@Slf4j
public class JsonHelper {

	private static final ObjectMapper objectMapper = new ObjectMapper();

	/**
	 * 将Map转为JSON串
	 * 
	 * @param params
	 * @return
	 */
	public static String stringify(Map<?, ?> params) {
		String paramsString = null;
		try {
			paramsString = objectMapper.writeValueAsString(params);
		} catch (JsonProcessingException e) {
			log.info("WriteValueAsString exception", e);
		}
		return paramsString;
	}
	
	public static String beanToJson(Object obj) {
		String paramsString = null;
		try {
			paramsString = objectMapper.writeValueAsString(obj);
		} catch (JsonProcessingException e) {
			log.info("WriteValueAsString exception", e);
		}
		return paramsString;
	}
	
	public static <T> T  jsonToBean(String json,Class<T> valueType) throws IOException {
		try {
			return objectMapper.readValue(json.getBytes(),valueType);
		} catch (JsonProcessingException e) {
			log.info("WriteValueAsString exception", e);
		}
		return null;
	}
}
