package com.up.mls.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.GetMapping;

import com.up.mls.service.system.IMenuService;
import com.up.mls.vo.system.Menu;
import com.up.mls.vo.system.User;

/**
 * 首页 业务处理
 *
 * @author j.x.j
 */
@Controller
public class IndexController extends AbstractController {
    @Autowired
    private IMenuService menuService;

    // 系统首页
    @GetMapping("/index")
    public String index(ModelMap mmap) {
        // 取身份信息
        User user = getUser();
        // 根据用户id取出菜单
        List<Menu> menus = menuService.selectMenusByUserId(user.getUserId());
        mmap.put("menus", menus);
        mmap.put("user", user);
        return "index";
    }

    // 系统首页
    @GetMapping("/login")
    public String login(ModelMap mmap) {
        return "login";
    }

}
