package com.up.mls.controller.app;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.up.mls.controller.AbstractController;
import com.up.mls.service.app.ShopConditionService;
import com.up.mls.vo.app.ShopCondition;
import com.up.mls.web.domain.AjaxResult;
import com.up.mls.web.page.TableDataInfo;

@Controller
@RequestMapping("appData")
public class AppDataController extends AbstractController{
	
	@Autowired
	private ShopConditionService shopConditionService;
	
	@RequestMapping("list")
	public String list() {
		
		return "app/shopCondition/list";
	}
	
	@RequestMapping("data")
	@ResponseBody
	public TableDataInfo data(ShopCondition shopCondition) {
		startPage();
		List<ShopCondition> list = shopConditionService.selectShopConditionList(shopCondition);
		System.out.println("list :"+list.size());
		return getDataTable(list);
	}
	
	@GetMapping("toSave")
	public String toSave() {
		return "app/shopCondition/add";
	}
	
	@RequestMapping("/save")
	@ResponseBody
	public AjaxResult save(ShopCondition shopCondition) {
		return toAjax(shopConditionService.insertShopCondition(shopCondition));
	}
	
	@GetMapping("/edit/{id}")
	public String edit(@PathVariable("id") String id,ModelMap mmap) {
		ShopCondition shopCondition =  shopConditionService.selectByPrimaryKey(id);
		mmap.put("shopCondition", shopCondition);
		return "app/shopCondition/edit";
	}
	
	@PostMapping("/editSave")
	@ResponseBody
	public AjaxResult editSave(ShopCondition shopCondition) {
		return toAjax(shopConditionService.updateShopCondition(shopCondition));
	}
	
	@PostMapping("/remove")
	@ResponseBody
	public AjaxResult remove(Long id) {
		shopConditionService.deleteById(id);
		return toAjax(1);
	}
	
}
