package com.up.mls.controller.assess;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.up.mls.controller.AbstractController;
import com.up.mls.service.assess.BusinessLoanService;
import com.up.mls.vo.assess.BusinessLoan;
import com.up.mls.web.page.TableDataInfo;


/**
 * 商办贷款Controller
 * 列表展示、标记已处理
 * @author joker
 *
 */
@Controller
@RequestMapping("businessLoan")
public class BusinessLoanController extends AbstractController{
	
	@Autowired
	private BusinessLoanService businessLoanService;
	
	@RequestMapping("list")
	public String office(ModelMap mmap) {
		return "bussinessLoan/list";
	}
	
	@RequestMapping("data")
	@ResponseBody
	public TableDataInfo list(BusinessLoan businessLoan) {
		startPage();
		List<BusinessLoan> businessLoans = businessLoanService.selectList(businessLoan);
		return getDataTable(businessLoans);
	}
	
	//标记已处理
	@ResponseBody
	@RequestMapping("processed")
	public String processed(BusinessLoan businessLoan) {
		businessLoanService.updateBusinessLoan(businessLoan);
		return "1";
	}
	
}
