package com.up.mls.controller.assess;

import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.up.mls.controller.AbstractController;
import com.up.mls.service.assess.OfficeAssessService;
import com.up.mls.vo.assess.OfficeAssess;
import com.up.mls.web.page.TableDataInfo;

/**
 * 商办评估Controller（写字楼）
 * 列表展示、评估操作
 * @author joker
 *
 */
@Controller
@RequestMapping("officeAssess")
public class OfficeAssessController extends AbstractController{

	@Autowired
	private OfficeAssessService officeAssessService;
	
	
	@RequestMapping("list")
	public String office(ModelMap mmap) {
		return "officeAssess/list";
	}
	
	@RequestMapping("data")
	@ResponseBody
	public TableDataInfo list(OfficeAssess officeAssess) {
		startPage();
		List<OfficeAssess> list = officeAssessService.selectList(officeAssess);
		return getDataTable(list);
	}
	
	@RequestMapping("/detail/{id}")
	public String detail(@PathVariable("id")Long id,ModelMap mmap) {
		mmap.put("officeAssess", officeAssessService.selectByPrimaryKey(id));
		return "officeAssess/detail";
	}
	
	//评估
	@ResponseBody
	@RequestMapping("/assessOffice")
	public String assessShop(OfficeAssess officeAssess) {
		officeAssess.setOperUserId(getUser().getUserId());
		officeAssess.setOperUserName(getUser().getUserName());
		officeAssess.setOperDate(new Date());
		officeAssess.setStatus("1");
		officeAssessService.updateOfficeAssess(officeAssess);
		return "1";
	}
}
