package com.up.mls.controller.assess;

import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.up.mls.controller.AbstractController;
import com.up.mls.service.assess.ShopAssessService;
import com.up.mls.vo.assess.ShopAssess;
import com.up.mls.web.page.TableDataInfo;

/**
 * 商办评估Controller（商铺）
 * 列表展示、评估操作
 * @author joker
 *
 */
@Controller
@RequestMapping("shopAssess")
public class ShopAssessController extends AbstractController{

	@Autowired
	private ShopAssessService shopAssessService;
	
	/**
	 * type 0:商铺 1:写字楼
	 */
	@RequestMapping("list/{type}")
	public String office(@PathVariable("type")String type,ModelMap mmap) {
		mmap.put("type", type);
		return "shopAssess/list";
	}
	
	@RequestMapping("data/{type}")
	@ResponseBody
	public TableDataInfo list(@PathVariable("type")String type,ShopAssess shopAssess) {
		startPage();
		shopAssess.setType(type);
		List<ShopAssess> list = shopAssessService.selectList(shopAssess);
		return getDataTable(list);
	}
	
	@RequestMapping("/detail/{id}")
	public String detail(@PathVariable("id")Long id,ModelMap mmap) {
		mmap.put("shopAssess", shopAssessService.selectByPrimaryKey(id));
		return "shopAssess/detail";
	}
	
	//评估
	@ResponseBody
	@RequestMapping("/assessShop")
	public String assessShop(ShopAssess shopAssess) {
		shopAssess.setOperUserId(getUser().getUserId());
		shopAssess.setOperUserName(getUser().getUserName());
		shopAssess.setOperDate(new Date());
		shopAssess.setStatus("1");
		shopAssessService.updateShopAssess(shopAssess);
		return "1";
	}
}
