package com.up.mls.controller.content;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.annotation.Secured;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.up.mls.controller.AbstractController;
import com.up.mls.service.content.IBrandAreaService;
import com.up.mls.service.content.IBrandBrandAreaService;
import com.up.mls.service.content.IBrandLinkmanService;
import com.up.mls.service.content.IBrandService;
import com.up.mls.vo.content.Brand;
import com.up.mls.vo.content.BrandArea;
import com.up.mls.vo.content.BrandLinkman;
import com.up.mls.web.domain.AjaxResult;
import com.up.mls.web.page.TableDataInfo;

/**
 * 品牌审核Controller
 * @author joker
 *
 */
@Controller
@RequestMapping("/content/brandAudit")
public class BrandAuditController extends AbstractController{
	
	private String prefix = "brandAudit";
	
	 @Autowired
	 private IBrandService iBrandService;
	 @Autowired
	 private IBrandAreaService iBrandAreaService;
	 @Autowired
	 private IBrandBrandAreaService iBrandBrandAreaService;
	 @Autowired
	 private IBrandLinkmanService iBrandLinkmanService;
	 
	 @Secured("content:brand:view")
	    @GetMapping()
	    public String index() {
	        return prefix + "/list";
	    }
	    
		@ResponseBody
		@RequestMapping("/list")
		public TableDataInfo list(Brand brand) {
			startPage();
			brand.setAuditStatus(1);//只查询待审核的
			List<Brand> articleList = iBrandService.selectList(brand);
			return getDataTable(articleList);
		}
		
		@GetMapping("/catDetailPage/{id}")
		public String catDetail(@PathVariable("id") String id,Model model){
			Brand brand = iBrandService.selectById(id);
			model.addAttribute("entity", brand);
			List<BrandArea> userBrandAreas = iBrandAreaService.findByLevel();
			model.addAttribute("userBrandAreas", userBrandAreas);
			List<String> brandAreaId = iBrandBrandAreaService.selectId(Integer.decode(id));
			model.addAttribute("brandAreaId", brandAreaId);
			List<BrandLinkman> brandLinkmen = iBrandLinkmanService.selectList(id);
			model.addAttribute("brandLinkmen", brandLinkmen);
			if(brandLinkmen.isEmpty()){
			    model.addAttribute("notAvailable","true");
	        }
			return prefix + "/audit";
		}
		
		//保存审核
		@ResponseBody
		@RequestMapping("saveAudit")
		public AjaxResult saveAudit(Brand brand) {
			iBrandService.updateForAuditStatus(brand, getUserId());
			return toAjax(1);
		}
}
