package com.up.mls.controller.content;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.annotation.Secured;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.up.mls.controller.AbstractController;
import com.up.mls.service.content.BrandContactsErrorService;
import com.up.mls.util.SpringSecurityUtils;
import com.up.mls.vo.content.BrandContactsError;
import com.up.mls.web.domain.AjaxResult;
import com.up.mls.web.page.TableDataInfo;



/**
 * 品牌联系人 纠错 Controller
 * 
 * 用户在APP端 提交品牌联系人纠错， 后台对提交的纠错联系人进行审核
 * 
 * @author joker
 *
 */
@Controller
@RequestMapping("/brandContactsError")
public class BrandContactsErrorController extends AbstractController{
	

	@Autowired
	private BrandContactsErrorService brandContactsErrorService;
	
	@Secured("brand:error")
	@RequestMapping("contactsError")
	public String list() {
		return "brandContactsError/list";
	}
	
	@Secured("error:list")
	@PostMapping("/list")
	@ResponseBody
	public TableDataInfo list(BrandContactsError brandContactsError) {
		startPage();
		List<BrandContactsError> list = brandContactsErrorService.selectbrandContactsErrorList(brandContactsError);
		return getDataTable(list);
	}
	
	@GetMapping("verify/{id}")
	public String verify(@PathVariable("id")Long id, ModelMap mmap) {
		 BrandContactsError brandContactsError = brandContactsErrorService.selectbrandContactsErrorById(id);
		 mmap.put("brandContactsError", brandContactsError);
	     return  "brandContactsError/verify";
	}
	
	/**
	 * 保存 品牌联系人纠错 审核
	 * @param brandContactsError
	 * @return
	 */
	@Secured("brand:edit")
	@PostMapping("saveVerify")
	@ResponseBody
	public AjaxResult saveVerify(BrandContactsError brandContactsError) {
		brandContactsError.setApproveUser(String.valueOf(SpringSecurityUtils.getUserId()));	//审批人
		return toAjax(brandContactsErrorService.updateBrandError(brandContactsError));
	}
	
}
