package com.up.mls.controller.monitor;

import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.annotation.Secured;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.up.mls.annotation.Log;
import com.up.mls.common.constant.BusinessType;
import com.up.mls.controller.AbstractController;
import com.up.mls.service.monitor.ILogininforService;
import com.up.mls.vo.monitor.LoginLogInfo;
import com.up.mls.web.domain.AjaxResult;
import com.up.mls.web.page.TableDataInfo;

/**
 * 系统访问记录
 * 
 * @author j.x.j
 */
@Controller
@RequestMapping("/system/logininfor")
public class LogininforController extends AbstractController
{
    private String prefix = "system/logininfor";

    @Autowired
    private ILogininforService logininforService;

    @Secured("monitor:logininfor:view")
    @GetMapping()
    public String logininfor()
    {
        return prefix + "/logininfor";
    }

    @Secured("monitor:logininfor:list")
    @PostMapping("/list")
    @ResponseBody
    public TableDataInfo list(LoginLogInfo logininfor)
    {
        startPage();
        List<LoginLogInfo> list = logininforService.selectLogininforList(logininfor);
        return getDataTable(list);
    }

    @Secured("monitor:logininfor:remove")
    @Log(title = "登陆日志", action = BusinessType.DELETE)
    @PostMapping("/remove")
    @ResponseBody
    public AjaxResult remove(String ids)
    {
        return toAjax(logininforService.deleteLogininforByIds(ids));
    }
}
