package com.up.mls.controller.news;

import com.up.mls.controller.AbstractController;
import com.up.mls.service.news.UserMsgService;
import com.up.mls.util.ServletUtils;
import com.up.mls.web.page.TableDataInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * 用户消息表
 */
@Controller
@RequestMapping("/userMsg")
public class UserMsgController extends AbstractController {

    private String prefix = "msg";

    @Autowired
    private UserMsgService userMsgService;

    @RequestMapping("/index")
    public String index() {
        return prefix + "/index";
    }

    /**
     * 消息列表
     *
     * @param request
     * @return
     */
    @ResponseBody
    @RequestMapping("/list")
    public TableDataInfo list(HttpServletRequest request) {
        Map<String, Object> parameters = ServletUtils.getParameters(request);
        startPage();
        List<Map<String, Object>> list = userMsgService.selectList(parameters);
        return getDataTable(list);
    }


    @GetMapping("/edit/{id}")
    public String edit(@PathVariable("id") String id, Model model){
        Map<String, Object> map = userMsgService.selectById(id);
        model.addAttribute("entity", map);
        return prefix + "/detail";
    }

}
