package com.up.mls.controller.office;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.annotation.Secured;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.up.mls.controller.AbstractController;
import com.up.mls.service.office.OfficeService;
import com.up.mls.service.system.IUserService;
import com.up.mls.util.SpringSecurityUtils;
import com.up.mls.vo.office.Office;
import com.up.mls.vo.system.User;
import com.up.mls.web.page.TableDataInfo;
/**
 * 写字楼分配Controller
 * 用户通过app或官网委托的写字楼（出租、出售）后台人员分配给经纪人跟进
 * 写字楼委托列表、分配写字楼
 * 
 * @author joker
 *
 */
@Controller
@RequestMapping("/distribution")
public class DistributionOfficeController extends AbstractController{
	
	@Autowired
	private OfficeService officeService;
	@Autowired
	private IUserService userService;
	
	@RequestMapping("list")
	public String office(int distStatus,ModelMap mmap) {
		String sysUserId = SpringSecurityUtils.getUserId().toString();
		if(distStatus == 1) {
			return "officeDistribution/listDist";
		}else {
			return "officeDistribution/list";
		}
	}
	
	@RequestMapping("data")
	@ResponseBody
	public TableDataInfo list(Office office) {
//		office.setIsQuery(isQueryParam(office));
		startPage();
		office.setUserId(SpringSecurityUtils.getUserId().toString());
		List<Office> offices = officeService.selectOfficeList(office);
		return getDataTable(offices);
	}
	
	/**
	 * 分配经济人
	 */
	@GetMapping("toDistribution")
	public String toDistribution(String ids, Model model) {
		//获取 经纪人列表
		String companyId = SpringSecurityUtils.getUser().getCompanyId().toString();
		List<User> list = userService.selectUserByRole(null, "经纪人", companyId);
		model.addAttribute("sysAccounts", list);
		model.addAttribute("ids", ids);
		return "officeDistribution/distribution";
	}
	
	/**
	 * 保存分配经济人
	 */
	@PostMapping("distribution")
	public @ResponseBody Integer distribution(String saleId,String ids, Model model) {
		System.out.println("saleId : "+saleId);
		int count = officeService.distribution(saleId, ids);
		return count;
	}
}
