package com.up.mls.controller.office;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.up.mls.controller.AbstractController;
import com.up.mls.service.content.ISlideShowService;
import com.up.mls.service.office.OfficeService;
import com.up.mls.vo.office.Office;
import com.up.mls.web.page.TableDataInfo;

/**
 *
 * 推荐写字楼
 *
 */
@Controller
@RequestMapping("officePromote")
public class OfficePromoteController extends AbstractController{

	@Autowired
	private OfficeService officeService;
	@Autowired
	private ISlideShowService iSlideShowService;
	
	@RequestMapping("list")
	public String office(String rentType,ModelMap mmap) {
		return "promote/office/recoList";
	}
	
	/**
	 * 写字楼推荐-分页数据
	 * @param office
	 * @return
	 */
	@RequestMapping("data")
	@ResponseBody
	public TableDataInfo list(Office office) {
		startPage();
		List<Office> offices = officeService.selectOfficeListForPromote(office);
		return getDataTable(offices);
	}
	
	//新增-写字楼推荐
	@ResponseBody
	@RequestMapping("/promoteOffice")
	public int assessOffice(Office office) {
		Office  entity=this.officeService.findEntityByOfficeNumber(office.getOfficeNumber());
		if(entity==null){
			return -1;//编号有误，查无数据
		}
		if(! "1".equals(entity.getOnlineStatus())){
			return -2;//写字楼是下架状态
		}
		office.setIfIndex("2");
		int res=officeService.updateOfficePromote(office);
		//更新首页缓存
		this.iSlideShowService.resetRedis(entity.getCityId()+"",null);
		return res;

	}
	
	//取消-写字楼推荐
	@ResponseBody
	@RequestMapping("/CanelPromoteOffice")
	public String CanelPromoteOffice(Office office) {
		office.setIfIndex("1");
		officeService.updateOfficePromote(office);
		//更新首页缓存
		Office  entityNew=this.officeService.selectByPrimaryKey(office.getId());
		this.iSlideShowService.resetRedis(entityNew==null?"110100":entityNew.getCityId()+"",null);
		return "1";
	}
	
	
	//调序号
	@ResponseBody
	@RequestMapping("/updateOfficeSort")
	public String updateOfficeSort(Office office) {
		officeService.updateOfficeSort(office);
		//更新首页缓存
		Office  entityNew=this.officeService.findEntityByOfficeNumber(office.getOfficeNumber());
		this.iSlideShowService.resetRedis(entityNew==null?"110100":entityNew.getCityId()+"",null);
		return "1";
	}
	
}
