package com.up.mls.controller.office;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.annotation.Secured;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.up.mls.controller.AbstractController;
import com.up.mls.service.office.OfficeService;
import com.up.mls.vo.office.Office;
import com.up.mls.web.domain.AjaxResult;
import com.up.mls.web.page.TableDataInfo;
/**
 * 写字楼核实Controller
 * @author joker
 *
 */
@Controller
@RequestMapping("officeVerify")
public class OfficeVerifyController extends AbstractController{

	@Autowired
	private OfficeService officeService;
	
	@RequestMapping("list")
	public String office(ModelMap mmap) {
		return "verify/office/list";
	}
	
	@Secured("office:list")
	@RequestMapping("data")
	@ResponseBody
	public TableDataInfo list(Office office) {
		startPage();
//		office.setOnlineStatus("0");
		office.setOfficeVerify(0);
		List<Office> offices = officeService.selectOfficeList(office);
		return getDataTable(offices);
	}
	
	/**
	 *跳转核实写字楼页面 
	 * @param 
	 * @return
	 */
	@GetMapping("toVerify/{id}")
	public String verifyAddPage(@PathVariable("id") Long id, ModelMap mmap) {
		mmap.put("office",officeService.detail(id));
		return "verify/office/verifyEdit";
	}
	
	/**
	 * 保存写字楼核实
	 * 0:拒绝 1:通过
	 */
	@PostMapping("saveVerify")
	@ResponseBody
	public AjaxResult saveVerify(@RequestBody Office office) {
		Map<String, String> map = new HashMap<>();
//		officeService.updateOfficeOnlineStatus(office);
		//officeService.updateOfficeAudit(office,getUserId());
		map.put("Type", "200");
		return toAjax(1);
	}
}
