package com.up.mls.controller.recommend;

import com.up.mls.controller.AbstractController;
import com.up.mls.controller.team.TeamController;
import com.up.mls.service.recommend.RecommendService;
import com.up.mls.util.ServletUtils;
import com.up.mls.util.StringUtils;
import com.up.mls.web.page.TableDataInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;
import java.util.Objects;

/**
 * 推荐朋友控制器
 */
@Controller
@RequestMapping("/recommend")
public class RecommendController extends AbstractController {

    private String prefix = "recommend";

    @Autowired
    private RecommendService recommendService;

    @GetMapping("/index")
    public String index() {
        return prefix + "/index";
    }

    @ResponseBody
    @PostMapping("/list")
    public TableDataInfo list(HttpServletRequest request) {
        Map<String, Object> parameters = ServletUtils.getParameters(request);
        TeamController.getDate(parameters);
        startPage();
        List<Map<String, Object>> list = recommendService.selectList(parameters);
        return getDataTable(list);
    }

    @RequestMapping("/edit")
    public String detail(HttpServletRequest request, Model model) {
        Map<String, Object> parameters = ServletUtils.getParameters(request);
        model.addAttribute("id", parameters.get("id"));
        model.addAttribute("beginDate", parameters.get("beginDate"));
        model.addAttribute("endDate", parameters.get("endDate"));
        return prefix + "/detail";
    }


    @ResponseBody
    @PostMapping("/detailList")
    public TableDataInfo detailList(HttpServletRequest request) {
        Map<String, Object> parameters = ServletUtils.getParameters(request);
//        if (StringUtils.isNotEmpty(parameters.get("BeginDate")+"")){
//            parameters.put("params[BeginTime]",parameters.get("BeginDate"));
//        }
//        if (StringUtils.isNotEmpty(parameters.get("EndDate")+"")){
//            parameters.put("params[EndTime]",parameters.get("EndTime"));
//        }
        TeamController.getDetailDate(parameters);
        startPage();
        List<Map<String, Object>> list = recommendService.selectDetail(parameters);
        return getDataTable(list);
    }


}
