package com.up.mls.controller.shop;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.up.mls.controller.AbstractController;
import com.up.mls.service.shop.ShopService;
import com.up.mls.vo.shop.Shop;
import com.up.mls.web.page.TableDataInfo;

/**
 * 推荐商铺Controller
 * @author joker
 * 包括：推荐商铺列表展示、新增推荐商铺、取消推荐商铺
 *
 */
@Controller
@RequestMapping("shopPromote")
public class ShopPromoteController extends AbstractController{

	@Autowired
	private ShopService shopService;
	
	@RequestMapping("list")
	public String shop(String rentType,ModelMap mmap) {
		return "promote/shop/list";
	}
	
	//1:出租 2:出售 3:新盘出租 4-新盘出售
	@RequestMapping("data")
	@ResponseBody
	public TableDataInfo list(Shop shop) {
		startPage();
		List<Shop> shops = shopService.selectShopListForPromote(shop);
		return getDataTable(shops);
	}
	
	//更新商铺推荐状态
	@ResponseBody
	@RequestMapping("/promoteShop")
	public String assessShop(Shop shop) {
		shop.setIfIndex("2");
		shopService.updateShopPromote(shop);
		return "1";
	}
	
	//更新商铺推荐状态
	@ResponseBody
	@RequestMapping("/CanelPromoteShop")
	public String CanelPromoteShop(Shop shop) {
		shop.setIfIndex("1");
		shopService.updateShopPromote(shop);
		return "1";
	}
}
