package com.up.mls.controller.shop;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.annotation.Secured;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.up.mls.controller.AbstractController;
import com.up.mls.service.shop.ShopService;
import com.up.mls.vo.shop.Shop;
import com.up.mls.web.domain.AjaxResult;
import com.up.mls.web.page.TableDataInfo;
/**
 * 商铺核实Controller
 * @author joker
 *
 */
@Controller
@RequestMapping("shopVerify")
public class ShopVerifyController extends AbstractController{

	@Autowired
	private ShopService shopService;
	
	@RequestMapping("list")
	public String shop(String rentType,ModelMap mmap) {
		return "verify/shop/list";
	}
	
	@Secured("shop:list")
	@RequestMapping("data")
	@ResponseBody
	public TableDataInfo list(Shop shop) {
		startPage();
//		shop.setOnlineStatus("0");
		shop.setIsQuery(1);
		shop.setShopVerify(1);
		List<Shop> shops = shopService.selectShopList(shop);
		return getDataTable(shops);
	}
	
	/**
	 *跳转核实商铺页面 
	 * 
	 * @param 
	 * @return
	 */
	@GetMapping("toVerify/{id}")
	public String verifyAddPage(@PathVariable("id") Long id, ModelMap mmap) {
		mmap.put("shop",shopService.detail(id));
		return "verify/shop/verifyEdit";
	}
	
	/**
	 * 保存商铺核实
	 * 0:拒绝 1:通过
	 */
	@Secured("shop:saveVerify")
	@PostMapping("saveVerify")
	@ResponseBody
	public AjaxResult saveVerify(@RequestBody Shop shop) {
		Map<String, String> map = new HashMap<>();
		shopService.updateShopVerify(shop,getUserId());
		map.put("Type", "200");
		return toAjax(1);
	}
}
