package com.up.mls.controller.system;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.up.mls.controller.AbstractController;
import com.up.mls.service.system.IAreasSerevice;
import com.up.mls.vo.system.Areas;

@Controller
@RequestMapping("/system/areas")
public class AreasController extends AbstractController {

	@Autowired
	private IAreasSerevice areasSerevice;

	@GetMapping("/byLevel/{level}")
	@ResponseBody
	public List<Areas> findByLevel(@PathVariable("level") int level) {
		return areasSerevice.findByLevel(level);
	}

	/**
	 * 查询已开通分站省份，只可查询登录人省份，超级管理员则可查询全部
	 * @param level
	 * @return
	 */
	@GetMapping("/byLevelAuth/{level}")
	@ResponseBody
	public List<Areas> byLevelAuth(@PathVariable("level") int level) {
		return areasSerevice.findByLevelAuth(level);
	}

	/**
	 * 根据省份id，查询已开通分站城市，只可查询登录人省份，超级管理员则可查询全部
	 * @param parentId
	 * @return
	 */
	@GetMapping("/findByParntJurisdiction/{parentId}")
	@ResponseBody
	public List<Areas> findByParntJurisdiction(@PathVariable("parentId") long parentId) {
		return areasSerevice.findByParntJurisdiction(parentId);
	}

	@GetMapping("/byParent/{parentId}")
	@ResponseBody
	public List<Areas> findByParnt(@PathVariable("parentId") long parentId) {
		return areasSerevice.findByParentId(parentId);
	}
	
	@GetMapping("/byCity")
	@ResponseBody
	public List<Areas> findByLevelByCity(HttpServletRequest request) {
		String level=request.getParameter("level");
		String parentId=request.getParameter("parentId");
		return areasSerevice.findByCityAuth(level, parentId);
	}
	
	/**
	 * 根据当前登录人cityId查询区域
	 * @return
	 */
	@ResponseBody
	@GetMapping("/findAreas")
	public List<Areas> findByAreas(){
		return areasSerevice.findByAreas();
	}
}
