package com.up.mls.controller.system;

import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.up.mls.controller.AbstractController;
import com.up.mls.service.system.BusinessParamService;
import com.up.mls.vo.system.BusinessParam;
import com.up.mls.web.domain.AjaxResult;
import com.up.mls.web.page.TableDataInfo;

@Controller
@RequestMapping("sys/businessParam")
public class BusinessParamController extends AbstractController{

	@Autowired
	private BusinessParamService bparamService;
	
	private String prefix = "system/businessParam";
	
	@GetMapping("toList")
	public String toList() {
		return prefix + "/list";
	}
	
	@PostMapping("data")
	@ResponseBody
	public TableDataInfo data() {
		List<Map<String,Object>> list = bparamService.selectList();
		return getDataTable(list);
	}
	
	@GetMapping("toAdd")
	public String toAdd() {
		return prefix + "/add";
	}
	
	@PostMapping("save")
	@ResponseBody
	public AjaxResult add(BusinessParam bparam) {
		return toAjax(bparamService.add(bparam));
	}
	
	@GetMapping("toEdit/{id}")
	public String toEdit(@PathVariable("id")Long id,ModelMap mmap) {
		mmap.put("map", bparamService.selectById(id));
		return prefix + "/edit";
	}
	
	@PostMapping("edit")
	@ResponseBody
	public AjaxResult edit(BusinessParam bparam) {
		return toAjax(bparamService.update(bparam));
	}
	
	@GetMapping("validateByCode")
	@ResponseBody
	public Boolean validateByCode(String code) {
		return bparamService.checkExit(code);
	}
}
