package com.up.mls.controller.system;

import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.up.mls.controller.AbstractController;
import com.up.mls.service.system.IDictionaryService;
import com.up.mls.util.SpringSecurityUtils;
import com.up.mls.vo.system.Dictionary;
import com.up.mls.web.domain.AjaxResult;
import com.up.mls.web.page.TableDataInfo;

/**
 * 部门信息
 * 
 * @author j.x.j
 */
@Controller
@RequestMapping("/system/diction")
public class DictionaryController extends AbstractController{

	@Autowired
	private IDictionaryService dictionaryService;
	
	@RequestMapping("list")
	public String list(String parentKey) {
		// 配套：135 标签：136
		String path = null;
		if("136".equals(parentKey)) {
			path = "system/dict/data/data";
		}
		if("135".equals(parentKey)) {
			path = "system/dict/support/data";
		}
		return path;
	}
	
	@RequestMapping("data")
	@ResponseBody
	public TableDataInfo data1(Dictionary dictionary) {
		startPage();
		List<Dictionary> list = dictionaryService.findByParentKey(dictionary);
//		System.out.println("list1 : "+list.size()+"    "+list.get(0).getdName()+"  "+list.get(0).getSort()+" "+list.get(0).getCreateTime());
		return getDataTable(list);
	}
	
	@RequestMapping("toSave")
	public String toSave(String id,ModelMap mmap) {
		System.out.println("aaaa "+id);
		mmap.put("parentKey", id);
		return "system/dict/data/add";
	}
	
	@PostMapping("save")
	@ResponseBody
	public AjaxResult save(Dictionary diction) {
		System.out.println("dition : "+diction.getdName()+"    "+diction.getSort());
		List<Dictionary> list = dictionaryService.findByParentKeyForAdd(diction);
		Dictionary dict = list.get(list.size()-1);
		int d_key = Integer.parseInt(dict.getdKey())+1;
		int d_value = Integer.parseInt(dict.getdValue())+1;
		diction.setdKey(String.valueOf(d_key));
		diction.setdValue(String.valueOf(d_value));
		diction.setFlag(1);
		diction.setDescription(diction.getdName());
		Integer userId = Integer.valueOf(SpringSecurityUtils.getUserId().toString());
		diction.setCreateUser(userId);
		diction.setUpdateUser(userId);
		diction.setCreateTime(new Date());
		diction.setUpdateTime(new Date());
		
		dictionaryService.insert(diction);
		return toAjax(1);
	}
	
	@GetMapping("/edit/{key}")
	public String edit(@PathVariable("key") String key, ModelMap mmap) {
		mmap.put("dict", dictionaryService.findBydKey(key));
		return "system/dict/data/edit";
	}
	
	@PostMapping("/edit")
	@ResponseBody
	public AjaxResult editSave(Dictionary diction) {
		System.out.println("bbbb");
		return toAjax(dictionaryService.updateByPrimaryKeySelective(diction));
	}
	
	@PostMapping("/remove/{id}")
	@ResponseBody
	public AjaxResult remove(@PathVariable("id") String key) {
		System.out.println("id : "+key);
		dictionaryService.deleteByPrimaryKey(key);
		return toAjax(1);
	}
	
	public static void main(String[] args) {
		String a = "106107";
		int b = Integer.parseInt(a);
		int c = b+1;
		System.out.println("c : "+ c);
	}
}
