package com.up.mls.controller.system;

import java.io.IOException;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.collections4.CollectionUtils;
import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
import org.apache.commons.lang3.RandomStringUtils;
import org.apache.commons.lang3.StringUtils;

import com.aliyun.oss.OSS;
import com.aliyun.oss.OSSClientBuilder;

@WebServlet(asyncSupported = true, urlPatterns = "/osssignuature")
public class PostObjectPolicy extends HttpServlet {

	private static final long serialVersionUID = 5522372203700422672L;
	private static final String endpoint = "oss-cn-beijing.aliyuncs.com";
	private static final String accessId = "LTAIx3azJBJDWGXr";
	private static final String accessKey = "oWRDyoySkCyCJXzVHHzuGode5w7JaB";
	private static final String bucket = "up-sell";
	private static final String configJson ="{\"videoMaxSize\":102400000,\"videoActionName\":\"uploadvideo\",\"fileActionName\":\"uploadfile\",\"fileManagerListPath\":\"/article/file/\",\"imageCompressBorder\":1600,\"imageManagerAllowFiles\":[\".png\",\".jpg\",\".jpeg\",\".gif\",\".bmp\"],\"imageManagerListPath\":\"/upload/image/\",\"fileMaxSize\":51200000,\"fileManagerAllowFiles\":[\".png\",\".jpg\",\".jpeg\",\".gif\",\".bmp\",\".flv\",\".swf\",\".mkv\",\".avi\",\".rm\",\".rmvb\",\".mpeg\",\".mpg\",\".ogg\",\".ogv\",\".mov\",\".wmv\",\".mp4\",\".webm\",\".mp3\",\".wav\",\".mid\",\".rar\",\".zip\",\".tar\",\".gz\",\".7z\",\".bz2\",\".cab\",\".iso\",\".doc\",\".docx\",\".xls\",\".xlsx\",\".ppt\",\".pptx\",\".pdf\",\".txt\",\".md\",\".xml\"],\"fileManagerActionName\":\"listfile\",\"snapscreenInsertAlign\":\"none\",\"scrawlActionName\":\"uploadscrawl\",\"videoFieldName\":\"upfile\",\"imageCompressEnable\":true,\"videoUrlPrefix\":\"\",\"fileManagerUrlPrefix\":\"https://up-sell.oss-cn-beijing.aliyuncs.com\",\"catcherAllowFiles\":[\".png\",\".jpg\",\".jpeg\",\".gif\",\".bmp\"],\"imageManagerActionName\":\"listimage\",\"snapscreenPathFormat\":\"/article\",\"scrawlPathFormat\":\"/article\",\"scrawlMaxSize\":2048000,\"imageInsertAlign\":\"none\",\"catcherPathFormat\":\"/article\",\"catcherMaxSize\":2048000,\"snapscreenUrlPrefix\":\"\",\"imagePathFormat\":\"/article\",\"imageManagerUrlPrefix\":\"https://up-sell.oss-cn-beijing.aliyuncs.com\",\"scrawlUrlPrefix\":\"\",\"scrawlFieldName\":\"upfile\",\"imageMaxSize\":20480000,\"imageAllowFiles\":[\".png\",\".jpg\",\".jpeg\",\".gif\",\".bmp\"],\"snapscreenActionName\":\"uploadimage\",\"catcherActionName\":\"catchimage\",\"fileFieldName\":\"upfile\",\"fileUrlPrefix\":\"\",\"imageManagerInsertAlign\":\"none\",\"catcherLocalDomain\":[\"127.0.0.1\",\"localhost\",\"img.baidu.com\"],\"filePathFormat\":\"/ueditor/jsp/upload/file/{yyyy}{mm}{dd}/{time}{rand:6}\",\"videoPathFormat\":\"/ueditor/jsp/upload/video/{yyyy}{mm}{dd}/{time}{rand:6}\",\"fileManagerListSize\":20,\"imageActionName\":\"_UploadFile\",\"imageFieldName\":\"article/{yyyy}{mm}{dd}/{time}{rand:6}\",\"imageUrlPrefix\":\"https://up-sell.oss-cn-beijing.aliyuncs.com\",\"scrawlInsertAlign\":\"none\",\"fileAllowFiles\":[\".png\",\".jpg\",\".jpeg\",\".gif\",\".bmp\",\".flv\",\".swf\",\".mkv\",\".avi\",\".rm\",\".rmvb\",\".mpeg\",\".mpg\",\".ogg\",\".ogv\",\".mov\",\".wmv\",\".mp4\",\".webm\",\".mp3\",\".wav\",\".mid\",\".rar\",\".zip\",\".tar\",\".gz\",\".7z\",\".bz2\",\".cab\",\".iso\",\".doc\",\".docx\",\".xls\",\".xlsx\",\".ppt\",\".pptx\",\".pdf\",\".txt\",\".md\",\".xml\"],\"catcherUrlPrefix\":\"https://up-sell.oss-cn-beijing.aliyuncs.com\",\"imageManagerListSize\":20,\"catcherFieldName\":\"source\",\"videoAllowFiles\":[\".flv\",\".swf\",\".mkv\",\".avi\",\".rm\",\".rmvb\",\".mpeg\",\".mpg\",\".ogg\",\".ogv\",\".mov\",\".wmv\",\".mp4\",\".webm\",\".mp3\",\".wav\",\".mid\"]}";

	
	protected void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {

		OSS client =new OSSClientBuilder().build(endpoint, accessId, accessKey);

		// 1.创建DiskFileItemFactory对象，配置缓存用
		DiskFileItemFactory diskFileItemFactory = new DiskFileItemFactory();

		// 2. 创建 ServletFileUpload对象
		ServletFileUpload servletFileUpload = new ServletFileUpload(diskFileItemFactory);

		// 3. 设置文件名称编码
		servletFileUpload.setHeaderEncoding("utf-8");

		String action = request.getParameter("action");

		if (StringUtils.equals("config", action)) {
			response.setContentType("application/json");
			response.getWriter().println(configJson);
			client.shutdown();
		}
		
		if (StringUtils.isEmpty(action)||StringUtils.equals("_UploadFile", action)) {
			String returnString = null;
			// 4. 开始解析文件
			try {
				List<FileItem> items = servletFileUpload.parseRequest(request);
				if (CollectionUtils.isNotEmpty(items)) {
					for (FileItem fileItem : items) {
						if (fileItem.isFormField()) { // >> 普通数据
							//String info = fileItem.getString("utf-8");
							// System.out.println("info:" + info);
						} else { // >> 文件
							// 1. 获取文件名称
							String name = fileItem.getName();

							// 2. 获取文件的实际内容
							InputStream is = fileItem.getInputStream();
							// 3. 保存文件
							SimpleDateFormat format = new SimpleDateFormat("yyyyMMdd");
							String date =format.format(new Date());
							String key = splitStr(name);
							client.putObject(bucket, "article/"+date+"/" + key, is);
							if(StringUtils.equals("_UploadFile", action)) {
								returnString="{\"state\": \"SUCCESS\",\"original\": \""+name+"\",\"size\": \""+fileItem.getSize()+"\",\"title\": \""+name+"\",\"type\": \".png\",\"url\": \"/article/"+date+"/" +key+"\"}";
							}else {
								returnString="{\"state\": \"SUCCESS\",\"original\": \""+name+"\",\"size\": \""+fileItem.getSize()+"\",\"title\": \""+name+"\",\"type\": \".png\",\"url\": \"article/"+date+"/" +key+"\"}";

							}
						}
					}
				}
				response.setContentType("application/json");
				response.getWriter().println(returnString);
				client.shutdown();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		doGet(request, response);
	}

	public static void main(String[] args) {
//		String s = "upload/500722447.png";
//		String[] split2 = s.split("/");
//		System.out.println(split2[0] + "-----" + split2[1]);
//		String[] split = split2[1].split("\\.");
//		System.out.println(split[1]);
		String str = splitStr("500722447.png");
		System.out.println(str);
	}
	/**
	 * 处理字符串
	 * @param str
	 * @return
	 */
	public static String splitStr(String str) {
		 String key = RandomStringUtils.random(32, "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");
		 String[] split1 = str.split("\\.");
		 String url=key+"."+ split1[1];
		 return url;
	}
}
