package com.up.mls.controller.system;

import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.up.mls.controller.AbstractController;
import com.up.mls.service.system.ISysParamService;
import com.up.mls.vo.system.ISysParam;
import com.up.mls.web.domain.AjaxResult;
import com.up.mls.web.page.TableDataInfo;

@Controller
@RequestMapping("/sys/param")
public class SysParamController  extends AbstractController{
	
	@Autowired
	private ISysParamService sysParamService;
	
	@GetMapping("/list")
	public String list() {
		return "system/param/list";
	}
	
	@PostMapping("/data")
	@ResponseBody
	public TableDataInfo data(){
		List<Map<String,Object>> dataList = sysParamService.selectList();
		return getDataTable(dataList);
	}
	
	@GetMapping("/toEdit/{id}")
	public String toEdit(@PathVariable("id")Long id,ModelMap mmap) {
		mmap.put("map", sysParamService.selectById(id));
		return "system/param/edit";
	}
	
	@PostMapping("/saveEdit")
	@ResponseBody
	public AjaxResult saveEdit(ISysParam sysParam,ModelMap mmap) {
		return toAjax(sysParamService.update(sysParam));
	}
	
	@GetMapping("/add")
	public AjaxResult add(Long areaId){
		System.out.println("areaId : "+areaId);
		ISysParam sp = new ISysParam();
		sp.setAgentCrmNum(10);
		sp.setCompNum(100);
		sysParamService.add(sp);
		return toAjax(1);
	}
	
}
