package com.up.mls.controller.team;

import com.up.mls.controller.AbstractController;
import com.up.mls.service.team.TeamService;
import com.up.mls.util.ServletUtils;
import com.up.mls.web.page.TableDataInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.*;

@Controller
@RequestMapping("/team")
public class TeamController extends AbstractController {

    private String prefix = "team";

    @Autowired
    private TeamService teamService;

    @GetMapping("/index")
    public String index() {
        return prefix + "/index";
    }

    @ResponseBody
    @PostMapping("/list")
    public TableDataInfo list(HttpServletRequest request) {
        Map<String, Object> parameters = ServletUtils.getParameters(request);
        getDate(parameters);
        startPage();
        List<Map<String, Object>> list = teamService.selectList(parameters);
        return getDataTable(list);
    }

    @RequestMapping("/edit")
    public String detail(HttpServletRequest request, Model model) {
        Map<String, Object> parameters = ServletUtils.getParameters(request);
        model.addAttribute("id", parameters.get("id"));
        model.addAttribute("beginDate", parameters.get("beginDate"));
        model.addAttribute("endDate", parameters.get("endDate"));
        return prefix + "/detail";
    }

    @ResponseBody
    @PostMapping("/detailList")
    public TableDataInfo detailList(HttpServletRequest request) {
        Map<String, Object> parameters = ServletUtils.getParameters(request);
        getDetailDate(parameters);
        startPage();
        List<Map<String, Object>> list = teamService.selectDetail(parameters);
        return getDataTable(list);
    }

    /**
     * 获取前一个月时间
     *
     * @param map
     */
    public static void getDetailDate(Map<String, Object> map) {
        if ((map.get("BeginDate")+"").equals("null")) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            calendar.setTime(new Date());
            calendar.add(Calendar.MONTH, -1);
            Date m = calendar.getTime();
            String mon = format.format(m);
            System.out.println("过去一个月：" + mon);
            map.put("BeginDate", mon);
        }
    }

    /**
     * 获取前一个月时间
     *
     * @param map
     */
    public static void getDate(Map<String, Object> map) {
        if (Objects.isNull(map.get("params[BeginTime]")) && Objects.isNull(map.get("params[EndTime]"))) {
            Calendar calendar = Calendar.getInstance();
            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            calendar.setTime(new Date());
            calendar.add(Calendar.MONTH, -1);
            Date m = calendar.getTime();
            String mon = format.format(m);
            System.out.println("过去一个月：" + mon);
            map.put("params[BeginTime]", mon);
            map.put("BeginDate", mon);
        }
        if (Objects.nonNull(map.get("params[BeginTime]"))){
            map.put("BeginDate", map.get("params[BeginTime]"));
        }
        if (Objects.nonNull(map.get("params[EndTime]"))){
            map.put("EndDate", map.get("params[EndTime]"));
        }
    }
}
