package com.up.mls.handler;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.AuthenticationException;
import org.springframework.security.web.authentication.SimpleUrlAuthenticationFailureHandler;

import com.up.mls.common.constant.SystemConstants;
import com.up.mls.service.monitor.ILogininforService;
import com.up.mls.util.ServletUtils;
import com.up.mls.vo.monitor.LoginLogInfo;

public class AjaxAuthFailureHandler extends SimpleUrlAuthenticationFailureHandler {

	@Autowired
	private ILogininforService logininforService;
	@Override
	public void onAuthenticationFailure(HttpServletRequest request, HttpServletResponse response,
			AuthenticationException exception) throws IOException, ServletException {
		ServletUtils.printWriter(response, "{\"status\":\"error\",\"msg\":\"登录失败\"}");
		logininforService.insertLogininfor(new LoginLogInfo(request.getParameter("username"),SystemConstants.FAIL,"登录失败"));
	}
}
