package com.up.mls.handler;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.Authentication;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.security.web.authentication.SimpleUrlAuthenticationSuccessHandler;

import com.up.mls.common.constant.SystemConstants;
import com.up.mls.service.monitor.ILogininforService;
import com.up.mls.service.system.IUserService;
import com.up.mls.util.ServletUtils;
import com.up.mls.util.SpringSecurityUtils;
import com.up.mls.vo.monitor.LoginLogInfo;
import com.up.mls.vo.system.User;

public class AjaxAuthSuccessHandler extends SimpleUrlAuthenticationSuccessHandler {

	@Autowired
	private ILogininforService logininforService;
	@Autowired
	private IUserService userService;

	@Override
	public void onAuthenticationSuccess(HttpServletRequest request, HttpServletResponse response, Authentication auth)
			throws IOException, ServletException {
		User user = userService.selectUserById(SpringSecurityUtils.getUserId());
		ServletUtils.getSession().setAttribute("currUserProvinceId", user.getCompany().getProvinceId());;
		ServletUtils.getSession().setAttribute("currUserCityId", user.getCompany().getCityId());
		ServletUtils.getSession().setAttribute("loginName", user.getLoginName());
		
		ServletUtils.printWriter(response, "{\"code\":\"200\",\"msg\":\"登录成功\"}");
		logininforService.insertLogininfor(new LoginLogInfo(SpringSecurityUtils.getLoginName(),SystemConstants.SUCCESS, "登录成功"));
	}

	public static void main(String[] args) {
		BCryptPasswordEncoder b = new BCryptPasswordEncoder();
		System.out.println(b.encode("123456"));
	}

}
