package com.up.mls.mapper.office;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;

import com.up.mls.vo.office.Audit;
import com.up.mls.vo.office.Office;

public interface OfficeMapper {
	
	/**
	 * 根据条件分页查询用户对象
	 * 
	 * @param brand
	 *            用户信息
	 * @return 品牌信息集合信息
	 */
	public List<Office> selectOfficeList(Office office);
	
	public Office selectByPrimaryKey(Long id);
	
	public Office findEntityByOfficeNumber(String shopNumber);
	
	public int insertOffice(Office office);
	
	public int updateOffice(Office office);
	
	public int updateOfficeDistStatus(Office office);
	
	public int updateOfficeOnlineStatus(Office office);
	
	public String selectMaxOfficeNum();
	
	public int selectOnOfflineCount(@Param("onlineStatus")String onlineStatus, @Param("rentType") String rentType);
	
	public List<Office> selectOfficeListForPromote(Office office);
	public int updateOfficePromote(Office office);
	
	public int updateOfficeSort(Office office);
	
	public int updateOfficeAudit(Office office);

	public void saveRenlin(Office entity);
	
	public void saveRenlinBatch(Map<String,Object> map);

	public void saveOfficeAudit(Audit entity);

	public List<Audit> findAuditList(Map<String,Object> map);

	public void updateTopStatus(Office entity);
}
