package com.up.mls.mapper.shop;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;

import com.up.mls.vo.office.Audit;
import com.up.mls.vo.shop.Shop;
import com.up.mls.vo.shop.ShopExtend;

public interface ShopMapper {
	
	/**
	 * 根据条件分页查询用户对象
	 * 
	 * @param brand
	 *            用户信息
	 * @return 品牌信息集合信息
	 */
	public List<Shop> selectShopList(Shop shop);
	
	public Shop selectByPrimaryKey(Long id);
	
	public Shop selectByShopNumber(String shopNumber);
	
	public int insertShop(Shop shop);
	
	public int updateShop(Shop shop);
	
	public String selectMaxShopNum();
	
	public int isShopNumber(String shopNumber);
	
	public int updateShopOnlineStatus(Shop shop);
	
	public int selectOnOfflineCount(@Param("onlineStatus")String onlineStatus, @Param("rentType") String rentType);

    public List<Shop> selectShopListForPromote(Shop shop);
    
    public int updateShopPromote(Shop shop);
    
    public int updateShopSort(Shop shop);
    
    public int updateShopVerify(Shop shop);
    
    public int updateShopClaimForAudit(Shop shop);
    
    public int updateShopClaimForAuditByBatch(Map<String,Object> map);
    
    public int updateShopAudit(Shop shop);
    
    public void saveShopAudit(Audit entity);

	public List<Audit> findAuditList(String shopId);
	
	public int insertShopExtend(ShopExtend shopExtend);
	
	public void deleteShopExtendByShopId(Long shopId);
	
	public void updateTopStatus(Shop shop);

    Integer savePaidianAll(Shop shop);
}
