package com.up.mls.mapper.system;

import java.util.List;
import java.util.Map;

import com.up.mls.vo.system.Company;

/**
 * 公司 数据层
 * 
 * @author j.x.j
 *
 */
public interface CompanyMapper {

	/**
	 * 新增公司
	 * 
	 * @param company
	 * @return
	 */
	int insertCompany(Company company);

	/**
	 * 更新公司信息
	 * 
	 * @param company
	 * @return
	 */
	int updateCompany(Company company);

	/**
	 * 查询公司列表
	 * 
	 * @param company
	 * @return
	 */
	List<Company> selectCompanyList(Company company);

	/**
	 * 查询公司信息
	 * 
	 * @param company
	 *            查询公司属性
	 * @return
	 */
	Company selectCompany(Company company);

	/**
	 * 查询公司信息
	 * 
	 * @param company
	 *            查询公司属性
	 * @return
	 */
	Company selectById(Long id);

	/**
	 * 删除公司逻辑删除
	 * 
	 * @param companyIds
	 * @return
	 */
	int deleteCompanyById(Long companyId);

	/**
	 * 公司名称唯一查询
	 * 
	 * @param companyName
	 * @return
	 */
	Company checkCompanyKeyUnique(String companyName);

	/**
	 * 
	 * 查询所有的公司
	 * 
	 * @return
	 */
	List<Company> selectAll();

	/**
	 * 查询包含公司id的子公司数量
	 * 
	 * @param companyId
	 *            公司id
	 * @return
	 */
	int countByCompanyId(Long companyId);

	/**
	 * 根据省份和城市ID获取
	 * @param company
	 * @return
	 */
	List<Company> findByVerifyCity(Company company);
	
	
	List<Company> selectCityForCompany();

    List<Map<String, Object>> selectCompanyTree();
}
