package com.up.mls.redis;

import java.io.Serializable;
import java.util.List;
import java.util.Map;
import java.util.Set;

public interface RedisBaseDao {

	public String type(final String key);
	
	public boolean exists(final String key);
	
	public List<String> keys(final String pattern);
	
	public boolean renameNX(final String oldName, final String newName);
	
	public void flushAll();
	
	public void set(final String key,final Serializable value);
	
	public Object get(final String key);
	
	public void hMSet(final String key,final Map<String,Serializable> value);
	
	public List<Object> hVals(final String key);
	
	public List<Object> hMGet(final String key, final String ...fields);
	
	public Long hDel(final String key, final String ...fields);
	
	public Long hLen(final String key);
	
	public List<String> hKeys(final String key);
	
	public Map<String,Object> hMGetMap(final String key, final String ...fields);
	
	public Map<String,Object> hMGetMap(final String key);
	
	public Long del(final String ...keys);
	
	public void lPush(final String key,final Serializable ...value);
	
	public void lSet(final String key,final long index,final Serializable value);
	
	public List<Object> lRange(final String key,final long begin,final long end);
	
	public Object lIndex(final String key,final long index);
	
	public Long lRem(final String key,final long count,final Serializable value);
	
	public Long lLen(final String key);
	
	public Object lPop(final String key);
	
	public void sAdd(final String key,final Serializable ...value);
	
	public Long sRem(final String key,final Serializable value);
	
	public Long sCard(final String key);
	
	public Set<Object> sMembers(final String key);
	
	public Boolean sIsMember(final String key,final Serializable value);
	
	public Object sPop(final String key);
	
	public Long incrBy(final String key,final long value);
	
	public Long incr(final String key);
	
	public Long getIncr(final String key);
	
	public boolean expire(final String key, final long seconds);
}