/**
 * 
 */
package com.up.mls.run;

import javax.servlet.MultipartConfigElement;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.web.servlet.MultipartConfigFactory;
import org.springframework.context.annotation.Bean;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.security.config.annotation.method.configuration.EnableGlobalMethodSecurity;
import org.springframework.session.data.redis.config.annotation.web.http.EnableRedisHttpSession;
import org.springframework.transaction.annotation.EnableTransactionManagement;

import springfox.documentation.swagger2.annotations.EnableSwagger2;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SpringBootApplication(scanBasePackages = { "com.up.mls" })
@MapperScan(basePackages = { "com.up.mls.mapper" })
@EnableGlobalMethodSecurity(securedEnabled = false)
@EnableTransactionManagement
@EnableRedisHttpSession
@EnableAsync 

@EnableSwagger2
@EnableScheduling
public class UpSpringApplication {
   
	private static final Logger logger = LoggerFactory.getLogger(UpSpringApplication.class);
	
	/**  
     * 文件上传配置   
     * @return 
     */  
    @Bean  
    public MultipartConfigElement multipartConfigElement() {  
        MultipartConfigFactory factory = new MultipartConfigFactory();  
        //单个文件最大  
        factory.setMaxFileSize("10240KB"); //KB,MB 10240 
        /// 设置总上传数据总大小  
        factory.setMaxRequestSize("102400KB");  //102400
        return factory.createMultipartConfig();  
    } 
    
	public static void main(String[] args) {
		logger.info("开始启动[mls后台管理=============start]");
		SpringApplication.run(UpSpringApplication.class, args);
		logger.info("启动完成[mls后台管理=============end]");
	}
	
	
}
