package com.up.mls.service.assess.impl;

import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.up.mls.mapper.assess.LookShopMapper;
import com.up.mls.service.assess.LookShopService;
import com.up.mls.service.system.IUserService;
import com.up.mls.service.user.IAppUserService;
import com.up.mls.vo.assess.LookShop;
import com.up.mls.vo.system.User;
import com.up.mls.vo.user.AppUser;

@Service
public class LookShopServiceImpl implements LookShopService{

	@Autowired
	private LookShopMapper lookShopMapper;
	@Autowired
	private IAppUserService appUserService;
	@Autowired
	private IUserService userService;
	
	
	@Override
	public LookShop selectByPrimaryKey(Long id) {
		return lookShopMapper.selectByPrimaryKey(id);
	}
	
	@Override
	public List<LookShop> selectList(LookShop lookShop) {
		return lookShopMapper.selectList(lookShop);
	}
	
	/**
	 * 分配经济人
	 */
	@Override
	public int distribution(String agentId,String ids,User oper) {
		Integer count = 0;
		String[] str = ids.split(",");
		AppUser user = appUserService.selectByPrimaryKey(agentId);
		for(int i=0;i<str.length;i++) {
			 LookShop lookShop = lookShopMapper.selectByPrimaryKey(Long.valueOf(str[i]));
			 lookShop.setAgentId(Long.valueOf(agentId));
			 lookShop.setAgentName(user.getAccountName());
			 lookShop.setAgentPhone(user.getAccount());
			 lookShop.setDistTime(new Date());
			 lookShop.setOperUserId(oper.getUserId());
			 lookShop.setOperUserName(oper.getUserName());
			 lookShop.setDistStatus("1");	//0:未分配 1:已分配
			 lookShopMapper.updateLookShopDistStatus(lookShop);
			 count++;
		}
		return count;
	}

	

}
