package com.up.mls.service.content.impl;

import java.util.List;

import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.up.mls.mapper.content.ArticleMapper;
import com.up.mls.service.content.ArticleService;
import com.up.mls.service.content.ISlideShowService;
import com.up.mls.support.Convert;
import com.up.mls.util.SpringSecurityUtils;
import com.up.mls.vo.content.Article;
import com.up.mls.vo.content.Banner;
import com.up.mls.vo.system.User;

/**
 * <Description>
 *
 * @author Yuesiwei
 * @createDate 2019/02/18 上午11:40
 * @see com.up.mls.service.content.impl
 */
@Service
public class ArticleServiceImpl implements ArticleService {

	@Autowired
	private ArticleMapper articleMapper;
	@Autowired
	private ISlideShowService iSlideShowService;

	/*@Autowired
	private ICompanyService iCompanyService;*/
	
	private static final String advFlag = "0";

	@Override
	public List<Article> selectList(Article article) {
		User user = SpringSecurityUtils.getUser();
		article.setCreateBy(user.getUserId());
		return articleMapper.selectList(article);
	}

	@Override
	public int sava(Article article) {
		int resInt;
		String oldCitys=article.getCityId();
		User user = SpringSecurityUtils.getUser();
		if (null == article.getId()) {
			article.setCreateBy(user.getUserId());
			article.setAdvFlag(1);
			resInt= articleMapper.save(article);
			//new
			if(article !=null && StringUtils.isNotEmpty(article.getCityId())){
				for(String cityId:article.getCityId().split(",")){
					this.iSlideShowService.resetRedis(cityId, null);
				}
			}
		}else{
			article.setUpdateBy(user.getUserId());
			resInt= articleMapper.update(article);
			//old
			if(StringUtils.isNotEmpty(oldCitys)){
				for(String cityId:oldCitys.split(",")){
					this.iSlideShowService.resetRedis(cityId, null);
				}
			}
			//new
			Article newCitys=this.articleMapper.selectById(article.getId()+"");
			if(newCitys !=null && StringUtils.isNotEmpty(newCitys.getCityId())){
				for(String cityId:newCitys.getCityId().split(",")){
					this.iSlideShowService.resetRedis(cityId, null);
				}
			}
		}
		//循环清空缓存
		
		return resInt;
	}

	@Override
	public Article selectById(String id) {
		return articleMapper.selectById(id);
	}

	@Override
	public int remove(String ids) throws Exception {
		String[] id = ids.split(",");
		for (int i = 0; i < id.length; i++) {
			String status = articleMapper.selectAdvFlag(id[i]);
			if (status.equals(advFlag)) {
				throw new Exception("上架数据不可删除");
			}
		}
		for(String temp:id){
			//循环清空缓存
			Article entity= this.articleMapper.selectById(temp);
			if( entity !=null && StringUtils.isNotEmpty(entity.getCityId())){
				for(String cityId:entity.getCityId().split(",")){
					this.iSlideShowService.resetRedis(cityId, null);
				}
			}
		}
		int resInt=articleMapper.remove(Convert.toIntArray(",", ids));
 		return resInt;
	}

}
