package com.up.mls.service.content.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.up.mls.mapper.content.MogulMapper;
import com.up.mls.service.content.IMogulService;
import com.up.mls.service.system.ICompanyService;
import com.up.mls.support.Convert;
import com.up.mls.util.SpringSecurityUtils;
import com.up.mls.vo.content.Mogul;
import com.up.mls.vo.system.Company;
import com.up.mls.vo.system.User;

import java.util.List;

/**
 * <Description>
 * 大咖
 *
 * @author Yuesiwei
 * @createDate 2019/02/19 上午10:48
 * @see com.up.mls.service.content.impl
 */
@Service
public class MogulServiceImpl implements IMogulService {

    @Autowired
    private MogulMapper mogulMapper;

	@Autowired
	private ICompanyService iCompanyService;
	
    private static final String advFlag = "0";

    @Override
    public List<Mogul> selectList(Mogul mogul) {
    	mogul.setCreateBy(SpringSecurityUtils.getUserId());
        return mogulMapper.selectList(mogul);
    }

    @Override
    public int sava(Mogul mogul) {
		User user = SpringSecurityUtils.getUser();
		Company company = iCompanyService.selectCompanyById(user.getCompanyId());
        if (null == mogul.getId()) {
        	mogul.setCreateBy(user.getUserId());
        	mogul.setCityId(company.getCityId());
        	mogul.setProvinceId(company.getProvinceId());
            return mogulMapper.save(mogul);
        }
        mogul.setUpdateBy(user.getUserId());
        return mogulMapper.update(mogul);
    }

    @Override
    public Mogul selectById(String id) {
        return mogulMapper.selectById(id);
    }

    @Override
    public int remove(String ids) throws Exception {
        String[] id = ids.split(",");
        for (int i = 0; i < id.length; i++) {
            String status = mogulMapper.selectAdvFlag(id[i]);
            if (status.equals(advFlag)) {
                throw new Exception("上架数据不可删除");
            }
        }
        return mogulMapper.remove(Convert.toIntArray(",", ids));
    }


}
