package com.up.mls.service.deal;

import java.util.List;

import com.up.mls.vo.deal.ProjectOrder;


/**
 * 项目交易订单 服务接口
 * 
 * @author j.x.j
 *
 */
public interface ProjectOrderService {

	/**
	 * 查询项目交易订单list
	 * 根据交易低订单项目的类别（销售交易、招商交易），查询各自对应的历史
	 * 条件查询
	 * 
	 * 包括：订单项目对应的城市
	 * 
	 * @param projectOrder
	 * @return List - ProjectOrder
	 */
	List<ProjectOrder> findProjectOrder(ProjectOrder projectOrder);
	
	
	/**
	 * 根据项目交易订单 订单号查询订单详情
	 * 
	 * @param orderNo
	 *            交易订单号
	 * @return
	 */
	public ProjectOrder findByProjectOrderNo(String orderNo);
	
	
	/**
	 * 查询项目交易订单list
	 * 根据交易低订单项目的类别（销售交易、招商交易），查询各自对应的历史
	 * 条件查询
	 * 
	 * 包括：订单项目对应的城市
	 * 
	 * @param projectOrder
	 * @return List - ProjectOrder
	 */
	List<ProjectOrder> findOfficeOrder(ProjectOrder projectOrder);
	
	/**
	 * 写字楼流程
	 * @param projectOrder
	 * @return
	 */
	List<ProjectOrder> selectOfficeFlow(ProjectOrder projectOrder);
	/**
	 * 商铺流程
	 * @param projectOrder
	 * @return
	 */
	List<ProjectOrder> selectShopFlow(ProjectOrder projectOrder);

}
