package com.up.mls.service.deal.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.up.mls.mapper.deal.OfficeOrderMapper;
import com.up.mls.mapper.deal.ProjectOrderMapper;
import com.up.mls.mapper.system.AreasMapper;
import com.up.mls.service.deal.ProjectOrderService;
import com.up.mls.util.SpringSecurityUtils;
import com.up.mls.vo.deal.ProjectOrder;
import com.up.mls.vo.system.Areas;



/**
 * 
 *  项目交易订单 服务service
 * 
 * @author boat
 */
@Service
public class ProjectOrderServiceImpl implements ProjectOrderService {
	
	@Autowired
	private ProjectOrderMapper projectOrderMapper;
	@Autowired
	private OfficeOrderMapper officeOrderMapper;
	@Autowired
	private AreasMapper areasMapper;

	@Override
	public List<ProjectOrder> findProjectOrder(ProjectOrder projectOrder) {
		projectOrder.setUserId(SpringSecurityUtils.getUser().getUserId().toString());
		List<ProjectOrder> list = projectOrderMapper.selectProjectOrder(projectOrder);
		for(ProjectOrder p:list) {
			String id = p.getShop().getCityId().toString();
			Areas area = areasMapper.selectByPrimaryKey(id);
			p.setProjectCity(area.getAreaName());
		}
		return list;
	}

	@Override
	public ProjectOrder findByProjectOrderNo(String orderNo) {
		return projectOrderMapper.selectByPrimaryKey(orderNo);
	}
	
	
	
	
	

	
	@Override
	public List<ProjectOrder> findOfficeOrder(ProjectOrder projectOrder) {
		projectOrder.setUserId(SpringSecurityUtils.getUser().getUserId().toString());
		List<ProjectOrder> list = officeOrderMapper.selectOfficeOrder(projectOrder);
		for(ProjectOrder p:list) {
			Long id = p.getOffice().getCityId();
			Areas area = areasMapper.selectByPrimaryKey(id.toString());
			p.setProjectCity(area.getAreaName());
		}
		return list;
	}

	@Override
	public List<ProjectOrder> selectOfficeFlow(ProjectOrder projectOrder) {
		// TODO Auto-generated method stub
		return officeOrderMapper.selectOfficeFlow(projectOrder);
	}
	
	@Override
	public List<ProjectOrder> selectShopFlow(ProjectOrder projectOrder) {
		// TODO Auto-generated method stub
		return projectOrderMapper.selectShopFlow(projectOrder);
	}

	
}
