package com.up.mls.service.office;

import java.util.List;
import java.util.Map;

import com.up.mls.vo.office.Audit;
import com.up.mls.vo.office.CommissionEntity;
import com.up.mls.vo.office.Office;
import com.up.mls.vo.office.OfficeExtend;


public interface OfficeService {
	
	public List<Office> selectOfficeList(Office office);
	
	public Office selectByPrimaryKey(Long id);
	
	public Office findEntityByOfficeNumber(String officeNumber);
	
	public int insertOffice(Office office);
	
	public Office toEdit(Long id);
	
	public int updateOffice(Office office);
	
	public Office detail(Long id);
	/**
	 * 更新写字楼上下架状态
	 * @param office
	 * @return
	 */
	public int updateOfficeOnlineStatus(Office office);
	
	/**
	 * 统计 上架/下架 商铺数
	 */
	public int selectOnOfflineCount(String onlineStatus,String rentType);
	
	/**
	 * 获取当前最大商铺编号
	 * @return
	 */
	public String findNextOfficeNumber(String pre);
	
	public List<Office> selectOfficeListForPromote(Office office);
	public int updateOfficePromote(Office office);
	
	public int updateOfficeSort(Office office);
	
	public int distribution(String saleId,String ids);
	
	public int updateOfficeAudit(Office entity,Long loginUserId,String loginUserName);

	CommissionEntity jsonCommission(String rentType, String commissionValue, String commissionType);

	int saveRenlin(Office entity);
	
	public int saveRenlinBatch(Map<String,Object> map);
	
	public int realseRenlinBatch(Map<String,Object> map);

	int saveOfficeAudit(Audit entity);

	List<Audit> findAuditList(String officeId);

	void jsonHuiXianOfficeCommission(Office office);

	OfficeExtend findExtendEntity(String officeId);

	void updateExtend(OfficeExtend offExtend);

	void addExtend(OfficeExtend offExtend);

	void addAudit(Office oldEn, Office newEn);

	int updateTopStatus(Office shop);


	
}
