package com.up.mls.service.photo.impl;

import com.up.mls.mapper.photo.ShopMoneyMapper;
import com.up.mls.service.photo.ShopMoneyService;
import com.up.mls.service.shop.ShopPhotoRulesService;
import com.up.mls.service.system.ICompanyService;
import com.up.mls.util.SpringSecurityUtils;
import com.up.mls.vo.shop.ShopPhoto;
import com.up.mls.vo.shop.ShopPhotoRules;
import com.up.mls.vo.system.Company;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ShopMoneyServiceImpl implements ShopMoneyService {

    @Autowired
    private ShopMoneyMapper shopMoneyMapper;

    @Autowired
    private ICompanyService companyService;

    @Autowired
    private ShopPhotoRulesService shopPhotoRulesService;


    @Override
    public List<ShopPhoto> selectWaitList(ShopPhoto shopPhoto) {
        shopPhoto.setSelectUserId(SpringSecurityUtils.getUserId());
        return getShopMoney(shopMoneyMapper.selectWaitList(shopPhoto));
    }


    @Override
    public ShopPhoto selectDetail(String parameter) {
        Long companyId = SpringSecurityUtils.getUser().getCompanyId();
        Company company = companyService.selectCompanyById(companyId);
        ShopPhotoRules shopPhotoRules = shopPhotoRulesService.selectCityId(company.getCityId());

        String[] str = parameter.split(",");
        ShopPhoto shopPhoto = shopMoneyMapper.selectDetail(str[0], str[1],String.valueOf(company.getCityId()));
        shopPhoto.setCount1Money(shopPhotoRules.getBaseBonus1());
        shopPhoto.setCount2Money(shopPhotoRules.getBaseBonus2());
        if (null != shopPhoto.getCount1()){
            shopPhoto.setCount(shopPhoto.getCount1());
        }
        if (null != shopPhoto.getCount2()){
            shopPhoto.setCount(shopPhoto.getCount2());
        }
        if (null != shopPhoto.getCount2() && null != shopPhoto.getCount1()){
            shopPhoto.setCount(shopPhoto.getCount1() + shopPhoto.getCount2());
        }
        if (null != shopPhoto.getCount1()){
            shopPhoto.setMoney(shopPhoto.getCount1() * shopPhotoRules.getBaseBonus1());
        }
        if (null != shopPhoto.getCount2()){
            shopPhoto.setMoney(shopPhoto.getCount2() * shopPhotoRules.getBaseBonus2());
        }
        if (null != shopPhoto.getCount1() && null != shopPhoto.getCount2()){
            shopPhoto.setMoney(shopPhoto.getCount1() * shopPhotoRules.getBaseBonus1() + shopPhoto.getCount2() * shopPhotoRules.getBaseBonus2());
        }
        if (shopPhoto.getCount() > 15) {
            shopPhoto.setAdditionalMoney(25);
        } else if (shopPhoto.getCount() > 10) {
            shopPhoto.setAdditionalMoney(10);
        } else if (shopPhoto.getCount() > 5) {
            shopPhoto.setAdditionalMoney(5);
        }
        if (null != shopPhoto.getAdditionalMoney()) {
            shopPhoto.setCountMoney(shopPhoto.getMoney() + shopPhoto.getAdditionalMoney());
        } else {
            shopPhoto.setCountMoney(shopPhoto.getMoney());
        }
        return shopPhoto;
    }


    @Override
    public int update(ShopPhoto shopPhoto) {
        return shopMoneyMapper.update(shopPhoto);
    }

    @Override
    public List<ShopPhoto> shopMoney(ShopPhoto shopPhoto) {
        shopPhoto.setSelectUserId(SpringSecurityUtils.getUserId());
        return getShopMoney(shopMoneyMapper.shopMoney(shopPhoto));
    }

    @Override
    public ShopPhoto selectFinishDetail(String parameter) {
        Long companyId = SpringSecurityUtils.getUser().getCompanyId();
        Company company = companyService.selectCompanyById(companyId);
        ShopPhotoRules shopPhotoRules = shopPhotoRulesService.selectCityId(company.getCityId());

        String[] str = parameter.split(",");
        ShopPhoto shopPhoto = shopMoneyMapper.selectFinishDetail(str[0], str[1],String.valueOf(company.getCityId()));
        shopPhoto.setCount1Money(shopPhotoRules.getBaseBonus1());
        shopPhoto.setCount2Money(shopPhotoRules.getBaseBonus2());
        if (null != shopPhoto.getCount1()){
            shopPhoto.setCount(shopPhoto.getCount1());
        }
        if (null != shopPhoto.getCount2()){
            shopPhoto.setCount(shopPhoto.getCount2());
        }
        if (null != shopPhoto.getCount2() && null != shopPhoto.getCount1()){
            shopPhoto.setCount(shopPhoto.getCount1() + shopPhoto.getCount2());
        }
        if (null != shopPhoto.getCount1()){
            shopPhoto.setMoney(shopPhoto.getCount1() * shopPhotoRules.getBaseBonus1());
        }
        if (null != shopPhoto.getCount2()){
            shopPhoto.setMoney(shopPhoto.getCount2() * shopPhotoRules.getBaseBonus2());
        }
        if (null != shopPhoto.getCount1() && null != shopPhoto.getCount2()){
            shopPhoto.setMoney(shopPhoto.getCount1() * shopPhotoRules.getBaseBonus1() + shopPhoto.getCount2() * shopPhotoRules.getBaseBonus2());
        }
        if (shopPhoto.getCount() > 15) {
            shopPhoto.setAdditionalMoney(25);
        } else if (shopPhoto.getCount() > 10) {
            shopPhoto.setAdditionalMoney(10);
        } else if (shopPhoto.getCount() > 5) {
            shopPhoto.setAdditionalMoney(5);
        }
        if (null != shopPhoto.getAdditionalMoney()) {
            shopPhoto.setCountMoney(shopPhoto.getMoney() + shopPhoto.getAdditionalMoney());
        } else {
            shopPhoto.setCountMoney(shopPhoto.getMoney());
        }
        return shopPhoto;

    }


    /**
     * 获取拍店奖金
     *
     * @return
     */
    public List<ShopPhoto> getShopMoney(List<ShopPhoto> shopPhotoList) {
        Long companyId = SpringSecurityUtils.getUser().getCompanyId();
        Company company = companyService.selectCompanyById(companyId);
        ShopPhotoRules shopPhotoRules = shopPhotoRulesService.selectCityId(company.getCityId());

        shopPhotoList.stream()
                .forEach(shopList -> {
                    shopList.setCount1Money(shopPhotoRules.getBaseBonus1());
                    shopList.setCount2Money(shopPhotoRules.getBaseBonus2());
                    shopList.setCount(shopList.getCount1() + shopList.getCount2());
                    shopList.setMoney(shopPhotoRules.getBaseBonus1() * shopList.getCount1() + shopPhotoRules.getBaseBonus2() * shopList.getCount2());
                    if (shopList.getCount() > 15) {
                        shopList.setAdditionalMoney(25);
                    } else if (shopList.getCount() > 10) {
                        shopList.setAdditionalMoney(10);
                    } else if (shopList.getCount() > 5) {
                        shopList.setAdditionalMoney(5);
                    }
                    if (null != shopList.getAdditionalMoney()) {
                        shopList.setCountMoney(shopList.getMoney() + shopList.getAdditionalMoney());
                    } else {
                        shopList.setCountMoney(shopList.getMoney());
                    }
                });
        return shopPhotoList;
    }

}
