package com.up.mls.service.photo.impl;


import com.up.mls.mapper.shop.ShopPhotoMapper;
import com.up.mls.service.photo.ShopPhotoService;
import com.up.mls.service.shop.ShopService;
import com.up.mls.service.system.ICompanyService;
import com.up.mls.util.SpringSecurityUtils;
import com.up.mls.vo.shop.Shop;
import com.up.mls.vo.shop.ShopPhoto;
import com.up.mls.vo.system.Company;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.List;

@Service
public class ShopPhotoServiceImpl implements ShopPhotoService {

    @Autowired
    private ShopPhotoMapper shopPhotoMapper;

    @Autowired
    private ShopService shopService;

    @Autowired
    private ICompanyService companyService;

    @Override
    public List<ShopPhoto> selectList(ShopPhoto shopPhoto) {
        shopPhoto.setSelectUserId(SpringSecurityUtils.getUserId());
        if (shopPhoto.getState() == 3) {
            return shopPhotoMapper.selectRefuseList(shopPhoto);
        }
        return shopPhotoMapper.selectList(shopPhoto);
    }

    @Override
    public ShopPhoto selectId(Long id) {
        return shopPhotoMapper.selectId(id);
    }


    @Override
    public int update(ShopPhoto shopPhoto) throws Exception {
        if (shopPhoto.getState() == 2) {
            ShopPhoto shopPhoto1 = shopPhotoMapper.selectId(shopPhoto.getId());
            Shop shop = new Shop();
            shop.setCityId(Long.valueOf(String.valueOf(shopPhoto1.getCityId())));//城市id
            shop.setPhone(shopPhoto1.getShopPhone()); //店主手机号码
            shop.setRealAddress(shopPhoto1.getAddress());//详细地址
            try {
                String[] str = shopPhoto1.getCoordinate().split(",");//经纬度
                shop.setPositionX(str[0]);
                shop.setPositionY(str[1]);
            } catch (Exception e) {

            }
            shop.setShopFlow("0");//更改为待认领
            shop.setCreateType("5");//商铺来源5 拍店
            shop.setImgs(shopPhoto1.getPhotoImgs());//展示图片
            // 设置一些默认值
            shop.setRentType("1");//默认出租
            shop.setCommissionValue(new BigDecimal(100));//默认佣金值
            shop.setCommission("1");
            shop.setCommissionType("1");//佣金类型：1-百分比 2-直接填金额
            shop.setBuildArea(new BigDecimal(100));//默认建筑面积
            shop.setShopName("拍店店铺名字");//默认商铺名字
            shop.setAgentId(new Long(1));//经纪人id
            Integer is = shopService.savePaidianAll(shop);


            if (is > 0) {
                Long companyId = SpringSecurityUtils.getUser().getCompanyId();
                Company company = companyService.selectCompanyById(companyId);
                if (company.getCityId() == 110100) {
                    if (shopPhoto.getLine() == 1) {
                        shopPhoto.setBonus(5);
                    } else {
                        shopPhoto.setBonus(3);
                    }
                } else {
                    shopPhoto.setBonus(2);
                }
                //更改节点到奖金列表
                shopPhoto.setGrant(1);
            } else {
                throw new Exception("数据进入待认领错误");
            }
        }
        return shopPhotoMapper.update(shopPhoto);
    }

    @Override
    public List<ShopPhoto> adoptList(ShopPhoto shopPhoto) {
        shopPhoto.setSelectUserId(SpringSecurityUtils.getUserId());
        return shopPhotoMapper.adoptList(shopPhoto);
    }

}
