package com.up.mls.service.shop;

import java.util.List;

import com.up.mls.vo.office.Audit;
import com.up.mls.vo.shop.Shop;


public interface ShopService {
	
	public List<Shop> selectShopList(Shop shop);
	
	public Shop selectByPrimaryKey(Long id);
	
	public Shop selectByShopNumber(String shopNumber);
	
	public int insertShop(Shop shop);
	
	public Shop toEdit(Long id);
	
	public int saveEdit(Shop shop);
	
	public int updateShop(Shop shop);
	
	public Shop detail(Long id);
	
	public int updateShopOnlineStatus(Shop shop);
	/**
	 * 根据商铺编号 查询商铺是否存在
	 * @param shopNumber	 商铺编号
	 * @return 0：不存在 1：存在
	 */
	public int isShopNumber(String shopNumber);
	/**
	 * 获取当前最大商铺编号
	 * @return
	 */
	public String findNextShopNumber();
	
	/**
	 * 统计 上架/下架 商铺数
	 */
	public int selectOnOfflineCount(String onlineStatus,String rentType);
	
	public List<Shop> selectShopListForPromote(Shop shop);
	public int updateShopPromote(Shop shop);
	
	public int updateShopSort(Shop shop);
	
	public int updateShopVerify(Shop shop,Long currId);
	
	/**
	 * 审核商铺认领
	 * @param shop	商铺
	 * @param currId 当前登录人ID
	 * @return 
	 */
	public int updateShopClaimForAudit(Shop shop,Long currId);
	
	public int updateShopClaimForAuditByBatch(Long[] ids,Long currId);
	
	public int releaseShop(Shop shop);
	/**
	 * 批量释放
	 * @param ids
	 * @param currId
	 * @return
	 */
	public int releaseShopByBatch(Long[] ids,Long currId);
	
	public int updateShopAudit(Shop shop,Long currId,String currName);
	
	public List<Audit> findAuditList(String shopId);

	int updateTopStatus(Shop shop);

	Integer savePaidianAll(Shop shop);
}
