package com.up.mls.service.system;

import java.util.List;

import com.up.mls.vo.system.Areas;
import com.up.mls.vo.system.User;

/**
 * 区域服务
 * 
 * @author j.x.j
 *
 */
public interface IAreasSerevice {

	/**
	 * 根据区域级别查询
	 * 
	 * @param level
	 *            级别 省、直辖市：1
	 * @return
	 */
	List<Areas> findByLevel(int level);
	
	public List<Areas> findByCityAuth(String level,String parentId);
	/**
	 * 数据隔离查询一级省市
	 * @param level
	 * @return
	 */
	List<Areas> findByLevelAuth(int level);

	List<Areas> findByRegions(Long regionsId);

	/**
	 * 根据父id数据隔离查询子区域
	 * 
	 * @param parentId
	 *            父区域id标识
	 * @return
	 */
	List<Areas> findByParentId(Long parentId);
	
	public List<Areas> findAreas(Areas areas);
	
	/**
	 * 查询品牌配置显示城市
	 * @param level
	 * @return
	 */
	List<Areas> selectBrnadCofigAreas(Areas areas);

	/**
	 * 数据隔离 查询子公司所在城市
	 * @param parentId
	 * @return
	 */
    List<Areas> findByParntAuth(long parentId);

    /**
     * 根据当前登录人cityId查询区域
     * @return
     */
	List<Areas> findByAreas();

	/**
	 * 根据cityId获取城市名称 安卓需要
	 * @param id
	 * @return
	 */
	Areas findByAreaName(Long id);

	List<Areas> findByParntJurisdiction(long parentId);
}
