package com.up.mls.service.system;

import java.util.List;
import java.util.Map;

import com.up.mls.vo.system.Company;

/**
 * 公司 服务层
 * 
 * @author j.x.j
 *
 */
public interface ICompanyService {

	/**
	 * 新增公司
	 * 
	 * @param company
	 * @return
	 */
	int insertCompany(Company company);

	/**
	 * 更新公司信息
	 * 
	 * @param company
	 * @return
	 */
	int updateCompany(Company company);

	/**
	 * 查询公司信息
	 * 
	 * @param company
	 * @return
	 */
	List<Company> selectCompanyList(Company company);

	/**
	 * 查看公司信息
	 * 
	 * @param companyId
	 *            公司ID
	 * @return
	 */
	Company selectCompanyById(Long companyId);

	/**
	 * 检测公司的名称是否唯一
	 * @param name 0：唯一  1:不唯一
	 * @return
	 */
	int checkCompanyNameUnique(Company company);

	/**
	 * 根据id删除company
	 * @param ids
	 * @return
	 */
	int deleteCompanyById(Long companyId);

	/**
	 * 
	 * @return
	 */
	List<Map<String, Object>> selectCompanyTree();

	/**
	 * 查询包含companyId的子公司数量
	 * @param companyId
	 * @return
	 */
	int countChildByCompanyId(Long companyId);

	/**
	 * 查询同省份下同城市是否存在分公司
	 * @param company
	 * @return
	 */
	List<Company> findByVerifyCity(Company company);
	
	List<Company> selectCityForCompany();

	List<Map<String, Object>> selectCompany();
}
