package com.up.mls.service.system.impl;

import java.util.Date;
import java.util.List;
import java.util.Objects;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.up.mls.mapper.system.AppDataMapper;
import com.up.mls.service.system.IAppDataService;
import com.up.mls.support.Convert;
import com.up.mls.util.SpringSecurityUtils;
import com.up.mls.vo.system.AppData;

@Service
public class AppDataServiceImpl implements IAppDataService {

	@Autowired
	private AppDataMapper appDataMapper;

	@Override
	public int edit(AppData appData) {
		if (Objects.isNull(appData.getId())) {
			appData.setCreateBy(SpringSecurityUtils.getUserId());
			appData.setCreateTime(new Date());
			return appDataMapper.insertSelective(appData);
		} else {
			appData.setUpdateBy(SpringSecurityUtils.getUserId());
			appData.setUpdateTime(new Date());
			return appDataMapper.updateByPrimaryKeySelective(appData);
		}
	}

	@Override
	public List<AppData> selectListByAppData(AppData appData) {
		return appDataMapper.selectListByAppData(appData);
	}

	@Override
	public int delByIds(String ids) {
		return appDataMapper.deleteByIds(Convert.toLongArray(ids));
	}

	@Override
	public AppData getAppData(Long id) {
		return appDataMapper.selectByPrimaryKey(id);
	}

	@Override
	public Long[] selectCityIdAll() {
		return appDataMapper.selectCityIdAll();
	}

}
