package com.up.mls.service.system.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.up.mls.mapper.system.AreasMapper;
import com.up.mls.service.system.IAreasSerevice;
import com.up.mls.service.system.ICompanyService;
import com.up.mls.util.SpringSecurityUtils;
import com.up.mls.vo.system.Areas;
import com.up.mls.vo.system.User;

/**
 * 
 * 区域服务
 * 
 * @author j.x.j
 */
@Service
public class AreasSereviceImpl implements IAreasSerevice {

	@Autowired
	AreasMapper areasMapper;
	
	@Autowired
	ICompanyService iCompanyService;

	@Override
	public List<Areas> findByLevel(int level) {
		Areas areas=new Areas();
		areas.setLevel(level);
		return areasMapper.selectAreas(areas);
	}
	@Override
	public List<Areas> findByLevelAuth(int level) {
		Areas areas=new Areas();
		areas.setLevel(level);
		areas.setUserId(Integer.parseInt(SpringSecurityUtils.getUserId().toString()));
		return areasMapper.findByLevelAuth(areas);
	}
	
	@Override
	public List<Areas> findByCityAuth(String level,String parentId) {
		long userId=SpringSecurityUtils.getUserId();
		Map areas=new HashMap();
		areas.put("level", level);
		areas.put("userId",userId);
		areas.put("parentId", parentId);
		return areasMapper.findByCityAuth(areas);
	}
	
	@Override
	public List<Areas> findByRegions(Long regionsId) {
		Areas areas=new Areas();
		areas.setRegionsId(regionsId);
		return areasMapper.selectAreas(areas);
	}

	@Override
	public List<Areas> findByParentId(Long parentId) {
		Areas areas=new Areas();
		areas.setParentId(parentId);
		return areasMapper.selectAreas(areas);
	}
	
	@Override
	public List<Areas> findAreas(Areas areas) {
		return areasMapper.selectAreas(areas);
	}
	

	@Override
	public List<Areas> selectBrnadCofigAreas(Areas areas) {
		// TODO Auto-generated method stub
		return areasMapper.selectBrnadCofigAreas(areas);
	}

	@Override
	public List<Areas> findByParntAuth(long parentId) {
		Areas areas=new Areas();
		areas.setParentId(parentId);
		areas.setUserId(Integer.parseInt(SpringSecurityUtils.getUserId().toString()));
		return areasMapper.selectAreasByParentAuth(areas);
	}
	

	@Override
	public List<Areas> findByAreas() {
		Long cityId = iCompanyService.selectCompanyById(SpringSecurityUtils.getUser().getCompanyId()).getCityId();
		return areasMapper.findByAreas(cityId);
	}

	@Override
	public Areas findByAreaName(Long id) {
		return areasMapper.findByAreaName(id);
	}

	@Override
	public List<Areas> findByParntJurisdiction(long parentId) {
		Areas areas=new Areas();
		areas.setParentId(parentId);
		areas.setUserId(Integer.parseInt(SpringSecurityUtils.getUserId().toString()));
		return areasMapper.findByParntJurisdiction(areas);
	}

}
