package com.up.mls.service.system.impl;

import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.up.mls.mapper.system.BusinessParamMapper;
import com.up.mls.service.system.BusinessParamService;
import com.up.mls.vo.system.BusinessParam;

@Service
public class BusinessParamServiceImpl implements BusinessParamService {

	@Autowired
	private BusinessParamMapper bparamMapper;
	
	@Override
	public List<Map<String, Object>> selectList() {
		return bparamMapper.selectList();
	}

	@Override
	public Map<String, Object> selectById(Long id) {
		return bparamMapper.selectById(id);
	}
	
	@Override
	public Map<String, Object> selectByCode(String code){
		return bparamMapper.selectByCode(code);
	}

	@Override
	public int add(BusinessParam bparam) {
		return bparamMapper.add(bparam);
	}

	@Override
	public int update(BusinessParam bparam) {
		return bparamMapper.update(bparam);
	}
	
	/**
	 * 检测 该code参数是否已存在
	 * @param code
	 * @return true/false
	 */
	@Override
	public boolean checkExit(String code) {
		return bparamMapper.selectCountByCode(code) > 0 ? true:false;
	}

}
