package com.up.mls.umeng;

import com.up.mls.config.UmengConfig;
import org.apache.commons.lang3.StringUtils;
import org.json.JSONArray;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * IOS、安卓推送
 */
public class UmengUtils {

    UmengConfig umengConfig = new UmengConfig();

    private static PushClient client = new PushClient();

    /**
     * ios 组推
     *
     * @param title   标题
     * @param content 内容
     * @param type    跳转类型 1跳转为消息列表 2跳转H5页面
     * @param msgId   跳转H5页面的消息id，没有则为空
     * @param list    用户id集合
     * @throws Exception
     */
    public void sendIOSGroupcast(String title, String content, String type, Integer msgId, List<Integer> list) throws Exception {
        if (list.size() == 0){
            return;
        }
        IOSGroupcast groupcast = new IOSGroupcast("5d79b4b00cafb2798700029a", "itkk2bfdthgkyufvrbvzkk9uvjbinokv");
        JSONObject filterJson = new JSONObject();
        JSONObject whereJson = new JSONObject();
        JSONArray tagArray = new JSONArray();
        JSONArray tagsArray = new JSONArray();
        JSONObject orsTag = new JSONObject();
        JSONObject alertJson = new JSONObject();
        for (int i = 0; i < list.size(); i++) {
            JSONObject testTag = new JSONObject();
            testTag.put("tag", list.get(i));
            tagsArray.put(testTag);
        }
        orsTag.put("or", tagsArray);
        tagArray.put(orsTag);
        whereJson.put("and", tagArray);
        filterJson.put("where", whereJson);
        System.out.println(filterJson.toString());
        groupcast.setFilter(filterJson);
        alertJson.put("title", title);
        alertJson.put("body", content);
        groupcast.setDiy("msgId", msgId);//消息id
        groupcast.setDiy("types", type);//跳转类型 1消息列表 2跳转消息H5页面
        groupcast.setAlert(alertJson);
        groupcast.setBadge(0);
        groupcast.setSound("default");
        groupcast.setProductionMode();
        client.send(groupcast);
    }

    /**
     * 安卓组推
     *
     * @param title 标题
     * @param body  内容
     * @param list  用户id列表
     * @param type  用户类型，1为普通用户，2为经纪人
     * @param msgId 消息id
     * @throws Exception
     */
//    public void sendAndroidGroupcast(String title, String body, List<Integer> list, String type, Integer msgId) throws Exception {
////        if (list.size() > 300) {
////            List<Integer> list1 = new ArrayList<>();
////            list1 = list.subList(0, 300);
////            sendAndroidGroupcast(title, body, list1, type, msgId);
////        } else {
////
////        }
//        if (list.size() == 0){
//            return;
//        }
//        AndroidGroupcast groupcast = new AndroidGroupcast("5d70b0d94ca357a7f600055a", "st5fljow0ibcsz5xuiq2sn37wawfrakp");
//        JSONObject filterJson = new JSONObject();
//        JSONObject whereJson = new JSONObject();
//        JSONArray tagArray = new JSONArray();
//        JSONObject extraJson = new JSONObject();
//        JSONArray orArray = new JSONArray();
//        JSONObject orJson = new JSONObject();
//        //存储用户id
//        for (int i = 0; i < list.size(); i++) {
//            JSONObject testTag = new JSONObject();
//            testTag.put("tag", list.get(i));
//            orArray.put(testTag);
//        }
//        orJson.put("or", orArray);
//        tagArray.put(orJson);
//        whereJson.put("and", tagArray);
//        filterJson.put("where", whereJson);
//        System.out.println(filterJson.toString());
//        groupcast.setFilter(filterJson);
//        groupcast.setTitle(title);
//        groupcast.setText(body);
//        //跳转H5页面
//        if (Objects.nonNull(msgId)) {
//            extraJson.put("baseUrl", "http://test-m.youpu100.cn/messageInfo?id=" + msgId + "&move=android&type=2");
//            //extraJson.put("baseUrl", "http://m.youpu100.cn/messageInfo?id=" + msgId + "&move=android&type=2");
//            groupcast.setActivity("com.up.upcbmls.view.activity.WebViewActivity");
//        }
//        if (Objects.isNull(msgId)){
//            //1-普通用户 2-经纪人
//            if (type.equals("1")) {
//                groupcast.setActivity("com.up.upcbmls.view.activity.MainOrdinaryUserActivity");
//            } else {
//                groupcast.setActivity("com.up.upcbmls.view.activity.MainAgentActivity");
//            }
//        }
//        extraJson.put("isShare", true);
//        extraJson.put("isMsgPush", "true");
//        extraJson.put("webTitle", title);
//        groupcast.setAfterOpenAction(AndroidNotification.AfterOpenAction.go_activity);
//        groupcast.setExtra(extraJson);
//        groupcast.setDisplayType(AndroidNotification.DisplayType.NOTIFICATION);
//        groupcast.setProductionMode();
//        client.send(groupcast);
//    }

    /**
     * 安卓组推
     *
     * @param title 标题
     * @param body  内容
     * @param list  用户id列表
     * @param type  用户类型，1为普通用户，2为经纪人
     * @param msgId 消息id
     * @throws Exception
     */
    public static void sendAndroidGroupcast(String title, String body, List<Integer> list, String type, Integer msgId) throws Exception {
//        if (list.size() > 300) {
//            List<Integer> list1 = new ArrayList<>();
//            list1 = list.subList(0, 300);
//            sendAndroidGroupcast(title, body, list1, type, msgId);
//        } else {
//
//        }
        if (list.size() == 0){
            return;
        }
        AndroidGroupcast groupcast = new AndroidGroupcast("5d70b0d94ca357a7f600055a", "st5fljow0ibcsz5xuiq2sn37wawfrakp");
        JSONObject filterJson = new JSONObject();
        JSONObject whereJson = new JSONObject();
        JSONArray tagArray = new JSONArray();
        JSONObject extraJson = new JSONObject();
        JSONArray orArray = new JSONArray();
        JSONObject orJson = new JSONObject();
        //存储用户id
        for (int i = 0; i < list.size(); i++) {
            JSONObject testTag = new JSONObject();
            testTag.put("tag", list.get(i));
            orArray.put(testTag);
        }
        orJson.put("or", orArray);
        tagArray.put(orJson);
        whereJson.put("and", tagArray);
        filterJson.put("where", whereJson);
        System.out.println(filterJson.toString());
        groupcast.setFilter(filterJson);
        groupcast.setTitle(title);
        groupcast.setText(body);
        //跳转H5页面
        if (Objects.nonNull(msgId)) {
            extraJson.put("baseUrl", "http://test-m.youpu100.cn/messageInfo?id=" + msgId + "&move=android&type=2");
            //extraJson.put("baseUrl", "http://m.youpu100.cn/messageInfo?id=" + msgId + "&move=android&type=2");
            groupcast.setActivity("com.up.upcbmls.view.activity.WebViewActivity");
        }
        if (Objects.isNull(msgId)){
            //1-普通用户 2-经纪人
            if (type.equals("1")) {
                groupcast.setActivity("com.up.upcbmls.view.activity.MainOrdinaryUserActivity");
            } else {
                groupcast.setActivity("com.up.upcbmls.view.activity.MainAgentActivity");
            }
        }
        extraJson.put("isShare", true);
        extraJson.put("isMsgPush", "true");
        extraJson.put("webTitle", title);
        groupcast.setAfterOpenAction(AndroidNotification.AfterOpenAction.go_activity);
        groupcast.setExtra(extraJson);
        groupcast.setDisplayType(AndroidNotification.DisplayType.NOTIFICATION);
        groupcast.setProductionMode();
        client.send(groupcast);
    }

//    public static void main(String[] args) throws Exception {
//        List<Integer> list = new ArrayList<>();
//        list.add(2);
//        sendAndroidGroupcast("试试这个11111", "内容", list,"1", null);
//    }
}
