package com.up.mls.util;

import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.fasterxml.jackson.databind.ObjectMapper;

/**
 * 获取地址类
 * 
 * @author j.x.j
 */
public class AddressUtils {
	private static final Logger log = LoggerFactory.getLogger(AddressUtils.class);

	public static final String IP_URL = "http://ip.taobao.com/service/getIpInfo.php";

	@SuppressWarnings("unchecked")
	public static String getRealAddressByIP(String ip) {
		String address = "";
		try {
			address = HttpUtils.sendGet(IP_URL, "ip=" + ip);

			ObjectMapper mapper = new ObjectMapper();
			Map<String, Object> m = mapper.readValue(address, Map.class);
			Map<String, Object> data = (Map<String,Object>) m.get("data");
			address = data.get("region").toString() + " " + data.get("city").toString();
			System.out.println(address);
			
		}

		catch (Exception e) {
			log.error("获取地理位置异常:", e);
		}
		return address;
	}

	public static void main(String[] args) {
		getRealAddressByIP("60.10.114.132");
	}
}
