/**
 * 
 */
package com.up.mls.util;

import java.math.BigDecimal;

import org.apache.commons.configuration.CompositeConfiguration;
import org.apache.commons.configuration.PropertiesConfiguration;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author mingguangz
 *
 */
public final class ConfigurationUtils {
	private static final Logger logger = LoggerFactory.getLogger(ConfigurationUtils.class);
	private final static String[] propertiesFile = {"configs/properties/config.properties"};
	private final static CompositeConfiguration configuration = new CompositeConfiguration();
	static {
		try {
			for(String f : propertiesFile){
				logger.info("Loading the configuration file "+f);
				configuration.addConfiguration(new PropertiesConfiguration(f));
			}
		} catch (Exception e) {
			logger.error(e.getMessage(), e);
		}
	}

	private ConfigurationUtils() { }

	public static String getStringValue(String key) {
		return configuration.getString(key);
	}

	public static int getIntValue(String key) {
		return configuration.getInt(key);
	}

	public static double getDoubleValue(String key) {
		return configuration.getDouble(key);
	}

	public static float getFloatValue(String key) {
		return configuration.getFloat(key);
	}

	public static boolean getBooleanValue(String key) {
		return configuration.getBoolean(key);
	}
	
	public static BigDecimal getBigDecimalValue(String key) {
		return configuration.getBigDecimal(key);
	}
	
	public static long getLongValue(String key) {
		return configuration.getLong(key);
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
	}

}
