package com.up.mls.util;

import java.text.MessageFormat;
import java.util.Map;
import java.util.Objects;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.lang3.StringUtils;

public class RequesUtil {

	static final String urlFormat = "{0} -> {1} ?{2}";// {0}:请求类型 {1}:url地址 {2}:查询参数

	public static String getRequstMethodAndUrlAndParam(HttpServletRequest request) {
		String url = request.getRequestURL().toString();
		String queryString = StringUtils.EMPTY;
		if (StringUtils.isNotBlank(url)) {
			if (Objects.equals(request.getMethod(), "GET")) {
				queryString = request.getQueryString();
			} else if (Objects.equals(request.getMethod(), "POST")) {
				Map<String, String[]> params = request.getParameterMap();
				for (String key : params.keySet()) {
					String[] values = params.get(key);
					for (int i = 0; i < values.length; i++) {
						String value = values[i];
						queryString += key + "=" + value + "&";
					}
				}
				if (StringUtils.isNotBlank(queryString)) {
					queryString = queryString.substring(0, queryString.length() - 1);
				}
			}

			return MessageFormat.format(urlFormat, request.getMethod(), url, queryString);
		}

		return StringUtils.EMPTY;

	}
}
