package com.up.mls.util;

import com.alibaba.fastjson.JSON;
import lombok.Getter;
import lombok.Setter;

@Setter
@Getter
public class Ret {

	private int status;

	private Object data;

	private String msg;
	
	public Ret(int status, Object result, String msg) {
		this.status = status;
		this.data = result;
		this.msg = msg;
	}

	public Ret(int status, String msg) {
		this.status = status;
		this.msg = msg;
	}

	public Ret(int status, Object data) {
		this.status = status;
		this.data = data;
	}

	public Ret(int status) {
		this.data = data;
	}

	public static String ok(Object data, String msg) {
		Ret fail = new Ret(0, data, msg);
		return JSON.toJSONString(fail);
	}

	public static String ok(String msg) {
		Ret ok = new Ret(0, msg);
		return JSON.toJSONString(ok);
	}

	public static String ok(Object data) {
		Ret ok = new Ret(0, data);
		return JSON.toJSONString(ok);
	}

	public static String ok() {
		Ret ok = new Ret(0);
		return JSON.toJSONString(ok);
	}

	public static String fail() {
		Ret ok = new Ret(1);
		return JSON.toJSONString(ok);
	}

	public static String fail(String msg) {
		Ret fail = new Ret(1, msg);
		return JSON.toJSONString(fail);
	}
}
