package com.up.mls.util;

import java.util.Objects;
import java.util.Optional;

import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.web.authentication.WebAuthenticationDetails;

import com.up.mls.vo.system.User;

public class SpringSecurityUtils {

	public static User getUser() {
		return (User) getAuthentication().getPrincipal();
	}

	public static Authentication getAuthentication() {
		return SecurityContextHolder.getContext().getAuthentication();

	}

	public static Long getUserId() {
		return getUser().getUserId();
	}

	public static String getIpAddress() {
		return ((WebAuthenticationDetails) getAuthentication().getDetails()).getRemoteAddress();
	}

	public static String getSessionId() {
		return ((WebAuthenticationDetails) getAuthentication().getDetails()).getSessionId();
	}

	public static String getLoginName() {
		return getUser().getLoginName();
	}

	/**
	 * 
	 * @return 138500:全公司<br>
	 *         138400:子公司:包括所有子公司及所有子公司下的所有部门<br>
	 *         138300:部门:所属部门及其子部门: 操作自己、下属和自己所属部门及子部门的数据<br/>
	 *         138200:个人:只能操作自己的数据
	 */
	public static Integer getDataAuth() {
		return Optional.ofNullable(getUser().getRoles()).map(rs -> {
			return rs.stream().filter(r -> Objects.nonNull(r.getDataAuth())).max((a1, a2) -> {
				return a1.getDataAuth() - a2.getDataAuth();
			}).get().getDataAuth();
		}).orElse(0);
	}
}
