package com.up.mls.vo.assess;

import java.math.BigDecimal;
import java.util.Date;

import com.up.mls.vo.BaseDomain;

import lombok.Getter;
import lombok.Setter;

/**
 * 写字楼委托表 找铺、找客
 * @author joker
 *
 */
@Setter
@Getter
public class LookOffice extends BaseDomain{

	/**
	 * 
	 */
	private static final long serialVersionUID = -7305378724424265588L;
	
	private String areaId;
	
	private String areaName;
	
	private String regionsName;
	
	private String regionsId;
	
	
	private String unitMin;
	
	private String unitMax;
	
	private String dailyRentMin;
	
	private String dailyRentMax;
	
	private String userName;
	
	private String telephone;
	
	private String remark;
	/**
	 * 委托类型：1-找铺 2-找客
	 */
	private String helpType;
	/**
	 * 委托类型: 1-写字楼求购 2-写字楼求租 3-写字楼新盘求购 4-写字楼新盘求租 5-写字楼出租 6-写字楼出售
	 */
	private String types;
	
	private String weituoDic;
	
	private BigDecimal reward;

	/**
	 * 分配状态 0:未分配 1:已分配
	 */
	private String distStatus;
	/**
	 * 经济人
	 */
	private Long agentId;
	private String agentPhone;
	private String agentName;
	/**
	 * 分配经济人时间
	 */
	private Date distTime;
	
	/**
	 * 操作人
	 */
	private Long operUserId;
	private String operUserName;



	//列表展示
	//区域-商圈
	private String areaRegions;
	//单价
	private String unitPrice;
	//日租金
	private String dailyPrice;



	/**
	 * 新增查询字段
	 */
	//单价
	private String minUnitPrice;
	private String maxUnitPrice;
	//日租金
	private String minDailyPrice;
	private String maxDailyPrice;
	//商圈id
	private String businessAreaId;

}
