package com.up.mls.vo.assess;

import java.math.BigDecimal;
import java.util.Date;

import com.up.mls.vo.BaseDomain;

import lombok.Getter;
import lombok.Setter;
/**
 * 商铺委托表 找铺、找客
 * @author joker
 *
 */
@Setter
@Getter
public class LookShop extends BaseDomain{

	/**
	 * 
	 */
	private static final long serialVersionUID = 4433120864163662564L;

	private String areaId;
	
	private String areaName;
	
	private String regionsName;
	
	private String regionsId;
	
	private String types;
	
	private String unitMin;
	
	private String unitMax;
	
	private String dailyRentMin;
	
	private String dailyRentMax;
	
	private String userName;
	
	private String telephone;
	
	private String remark;
	
	private String helpType;
	/**
	 *  '542', '商铺委托类型',
		10、商铺出租
		11、商铺出售
		12、商业新盘出租
		13、商业新盘出售
		14、商铺求租
		15、商铺求购
		16、商业新盘求租
		17、商业新盘求购
	 */
	private String weituoDic;
	
	private BigDecimal reward;
	
	/**
	 * 分配状态 0:未分配 1:已分配
	 */
	private String distStatus;
	/**
	 * 经济人
	 */
	private Long agentId;
	private String agentName;
	private String agentPhone;
	/**
	 * 分配经济人时间
	 */
	private Date distTime;
	/**
	 * 操作人
	 */
	private Long operUserId;
	private String operUserName;
	
	
	
	//列表展示
	//区域-商圈
	private String areaRegions;
	//单价
	private String unitPrice;
	//日租金
	private String dailyPrice;



	/**
	 * 新增查询字段
	 */
	//单价
	private String minUnitPrice;
	private String maxUnitPrice;
	//日租金
	private String minDailyPrice;
	private String maxDailyPrice;
	//商圈id
	private String businessAreaId;
}
