package com.up.mls.vo.content;

import com.up.mls.vo.BaseEntity;
import com.up.mls.vo.system.Dictionary;
import com.up.mls.vo.system.User;

import lombok.Data;

/**
 * <Description>
 * 文章资讯
 *
 * @author Yuesiwei
 * @createDate 2019/02/18 上午11:25
 * @see com.up.mls.vo.content
 */
@Data
public class Article extends BaseEntity {

	private static final long serialVersionUID = -2746095035657396097L;

	private Integer id;

    /**
     * 字典表
     */
    private Dictionary dictionary;
    
    /**
     * 后台用户表
     */
    private User user;

    /**
     * 标题
     */
    private String title;

    /**
     * 内容
     */
    private String content;

    /**
     * 图片路径
     */
    private String imgPath;

    /**
     * 摘要
     */
    private String description;

    /**
     * 是否前台展示 0展示；1不展示
     */
    private int advFlag;

    /**
     * 所属省
     */
    private Long provinceId;

    /**
     * 所属市
     */
    private String cityId;
    
    /**
     * 类型 广告  资讯
     */
    private Integer type;
    
    
    /**
     * 是否置顶 0置顶；1不置顶
     */
    private Integer top;

    /**
     * 排序字段，数组越大越靠前
     */
    private Integer sort;
    
    private String cityName;
    private String userType;
    private String adress;

}
