package com.up.mls.vo.content;

import com.up.mls.vo.BaseEntity;
import com.up.mls.vo.system.Dictionary;
import com.up.mls.vo.system.User;

import lombok.Data;

/**
 * <Description>
 * 首页展示信息
 *
 * @author Yuesiwei
 * @createDate 2019/02/19 上午10:43
 * @see com.up.mls.vo.content
 */
@Data
public class Banner extends BaseEntity {

	private static final long serialVersionUID = -6343616122855627954L;

    private Integer id;

    public User user;

    public Article article;

    public Dictionary dictionary;
    
    /**
     * 展示标题
     */
    public String title;
  
    /**
     * 展示描述
     */
    public String describes;
    
    /**
     * 类型 字典表104
     */
    public Integer type;
    
    /**
     * 跳转内容 id或url链接
     */
    public String jumpContent;
	
    /**
     * 跳转类型 字典105
     */
    public String jumpType;
    
    /**
     * App展示封面
     */
    public String appPic;
    
    /**
     * pc展示封面
     */
    public String pcPic;
    
    /**
     * 排序
     */
    public Integer sort;
    
    /**
     * 是否显示 0显示；1不显示
     */
    public Integer advFlag;

    /**
     * app跳转链接
     */
    private String appUrl;

    /**
     * pc跳转链接
     */
    private String pcUrl;
    /**
     * 所属省
     */
    private Long provinceId;

    /**
     * 所属市
     */
    private String cityId;
    
    private String userType;
    
    private String cityName;

    //传参
    private String articles;
    //非持久化字段
    private String isAppOrPc;
    private String url;
    private String pic;
    //位置  前段展示需要 1.pc 2.app 3.pc/app
    private Integer adress;
    

}
