package com.up.mls.vo.content;

import java.util.Date;

import org.springframework.util.StringUtils;

import com.up.mls.vo.BaseEntity;
import com.up.mls.vo.system.User;

import lombok.Data;

/**
 * 品牌
 * 
 * @author geeks
 *
 */
@Data
public class Brand extends BaseEntity {

	private static final long serialVersionUID = 2725437689965105192L;

	private Integer id;

	private BrandType brandType;

    /**
     * 后台用户表
     */
    private User user;

	/**
	 * 品牌名称
	 */
	private String name;

	/**
	 * 公司名称
	 */
	private String companyName;
	
	/**
	 * 品牌业态
	 */
	private String brandTypeId;
	
	private String brandTypeTwo;

	/**
	 * 扩展区域id
	 */
	private String areaId;

	/**
	 * 扩展区域
	 */
	private String expandArea;
	
	/**
	 * 合作最低年限
	 */
	private String cooperationLower;
	
	/**
	 * 合作最高年限
	 */
	private String cooperationUpper;
	
	/**
	 * 最低面积
	 */
	private String areaLower;
	
	/**
	 * 最高面积
	 */
	private String areaUpper;
	
	/**
	 * 排序
	 */
	private Integer sort;
	
	/**
	 * LOGO地址
	 */
	private String imgPath;
	/**
	 * 图片
	 */
	private String imgs;
	
	/**
	 * 是否前台展示 0展示；1不展示
	 */
	private Integer advFlag;
	
	/**
	 * 所属省
	 */
	private Long provinceId;
	
	/**
	 * 所属市
	 */
	private Long cityId;
	
	/**
	 * 描述
	 */
	private String description;
	/**
	 * 经营性质
	 */
	private String brandNature;
	
	
	/**
	 * 审核状态
	 */
	private Integer auditStatus;
	private Long auditAccount;
	private Date auditTime;
	//拒绝原因
	private String reasons;
	
	

	/**
	 * 后台展示平面图片
	 */
	public String[] getImgArray() {
		if (StringUtils.isEmpty(imgs)) {
			return null;
		} else {
			return imgs.split(",");
		}
	}

}
