package com.up.mls.vo.customer;

import java.math.BigDecimal;

import com.up.mls.vo.BaseEntity;
import com.up.mls.vo.system.Areas;
import com.up.mls.vo.user.AppUser;

import lombok.Getter;
import lombok.Setter;
/**
 * 客源实体类
 * @author joker
 *
 */
@Setter
@Getter
public class Customer extends BaseEntity{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 4082014577463399224L;

	/**
	 * 主键id
	 */
	private Integer id;

	/**
	 * 客户姓名
	 */
	private String name;
	
	/**
	 * 客户电话
	 */
	private String account;
	
	/**
	 * 委托类型
	 */
	private String type;
	 /**
	  * 单价
	  */
	private BigDecimal priceMax;
	
	private BigDecimal priceMin;
	/**
	 * 日租金
	 */
	private BigDecimal priceDayMax;
	
	private BigDecimal priceDayMin;
	/**
	 * 备注
	 */
	private String remarks;
	/**
	 * 委托合同
	 */
	private String entrustImg;
	
	/**
	 * 面积上限(整数)
	 */
	private BigDecimal wantAreaMax;

	/**
	 * 面积下限(整数)
	 */
	private BigDecimal wantAreaMin;
	
	/**
	 * 合作佣金
	 */
	private BigDecimal commission;
	
	/**
	 * 结佣时间（天数）
	 */
	private int commissionDate;
	
	/**
	 * 经济人
	 */
	private String createUser;
	private String createId;
	private AppUser agent;
	/**
	 * 经济人电话
	 */
	private String createTel;
	/**
	 * 平台服务费
	 */
	private String feeService;
	/**
	 * 上下架状态（0：下架 1：上架）
	 */
	private String status;
	/**
	 * 市id
	 */
	private Integer cityId;
	private Areas city;

}
