package com.up.mls.vo.operate;

import com.up.mls.vo.BaseEntity;
import com.up.mls.vo.system.User;

import lombok.Data;

/**
 * <Description>
 * 消息实体
 *
 * @author Yuesiwei
 * @createDate 2019/02/26 上午10:24
 * @see com.up.mls.vo.operate
 */
@Data
public class Msg extends BaseEntity {

	private static final long serialVersionUID = -7471128684070704058L;

	/**
     * 主键
     */
    private Integer id;


    private User user;

    /**
     * 描述
     */
    private String describes;

    /**
     * 标题
     */
    private String title;

    /**
     * 内容
     */
    private String content;

    /**
     * 目标人群：0全部应用；1部分用户
     */
    private Integer mode;

    /**
     * 推送渠道，0为ios，1为安卓
     */
    private String channel;

    /**
     * 用户类型 0为会员；1为非会员
     */
    private String userType;

    /**
     * 推送效果0打开应用；1打开指定页面
     */
    private Integer effect;

    /**
     * 页面类型，只有推送效果值为1时，此字段才会用到；0商铺详情；1资讯详情
     */
    private Integer pageType;

    /**
     * 商铺或者咨询详情id
     */
    private String pageId;

    /**
     * 推送位置0应用外消息；1应用内消息
     */
    private String position;

    /**
     * 推送用户数量
     */
    private Integer pushUser;

    /**
     * 打开用户数量
     */
    private Integer openUser;

    /**
     * 省id
     */
    private Long provinceId;

    /**
     * 市id
     */
    private Long cityId;
    
    
    private String cityName;

}
