package com.up.mls.vo.result;

import com.up.mls.vo.content.Article;
import com.up.mls.vo.system.Dictionary;
import com.up.mls.vo.system.User;
import lombok.Data;

import java.util.Date;

/**
 * @author liuwei
 * 轮播图返回vo对象
 */
@Data
public class SlideShowListResult {


    private Integer id;

    public User user;

    public Article article;

    public Dictionary dictionary;

    /**
     * 展示标题
     */
    public String title;

    /**
     * 展示描述
     */
    public String describes;

    /**
     * 类型 字典表104
     */
    public Integer type;

    /**
     * 跳转内容 id或url链接
     */
    public String jumpContent;

    /**
     * 跳转类型 字典105
     */
    public String jumpType;

    /**
     * App展示封面
     */
    public String appPic;

    /**
     * pc展示封面
     */
    public String pcPic;

    /**
     * 排序
     */
    public Integer sort;

    /**
     * 是否显示 0显示；1不显示
     */
    public Integer advFlag;

    /**
     * app跳转链接
     */
    private String appUrl;

    /**
     * pc跳转链接
     */
    private String pcUrl;
    /**
     * 所属省
     */
    private Long provinceId;

    /**
     * 所属市
     */
    private String cityId;
    private String userType;

    //传参
    private String articles;

    //位置  前段展示需要 1.pc 2.app 3.pc/app
    private Integer adress;

    //创建时间
    private Date createTime;
    //作者
    private String userName;
    private String cityName;

    //pic  判断url  展示
    private String pic;
    private String url;

}
