package com.up.mls.vo.shop;

import com.up.mls.vo.BaseDomain;
import com.up.mls.vo.system.Dictionary;
import com.up.mls.vo.user.AppUser;
import lombok.Data;

import java.util.Date;
import java.util.List;


@Data
public class ShopPhoto extends BaseDomain {

    /**
     * 店主手机号码
     **/
    private String shopPhone;

    /**
     * 拍店人id
     **/
    private Integer userId;

    /**
     * 拍店图片 用","号分割
     **/
    private String photoImgs;

    /**
     * 经纬度 用","号分割
     **/
    private String coordinate;

    /**
     * 详细地址
     **/
    private String address;

    /**
     * 拒绝原因
     **/
    private Integer refusal;

    /**
     * 审核状态
     **/
    private Integer state;

    /**
     * 审核时间
     **/
    private Date stateTime;

    /**
     * 奖金
     **/
    private Integer bonus;

    /**
     * 奖金发放状态 1未发放 2已发放 为空则为未审核或者审核拒绝
     **/
    private Integer grant;

    /**
     * 奖金发放审核时间
     **/
    private Date moneyTime;

    /**
     * 环线
     **/
    private Integer line;

    private Long cityId;

    private String account;
    private AppUser appUser;
    private List<String> img;
    private Dictionary dictionary;
    private Long selectUserId;

    /**
     * 五环内审核通过铺数
     **/
    private Integer count1;

    /**
     * 五环外审核通过铺数
     **/
    private Integer count2;

    /**
     * 五环内单价
     **/
    private Integer count1Money;

    /**
     * 五环外单价
     **/
    private Integer count2Money;

    /**
     * 审核通过总数
     **/
    private Integer count;

    /**
     * 基础奖金
     **/
    private Integer money;

    /**
     * 额外奖金
     **/
    private Integer additionalMoney;

    /**
     * 总金额
     **/
    private Integer countMoney;

    private String days;

}

