package com.up.mls.web.service;

import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.up.mls.service.system.IDictionaryService;
import com.up.mls.vo.system.Dictionary;

/**
 * html调用 thymeleaf 实现字典读取
 * 
 * @author j.x.j
 */
@Service("dict")
public class DictService {
	@Autowired
	private IDictionaryService dictionaryService;

	/**
	 * 根据父级id和value查询字典name值
	 * 
	 * @param parentKey
	 * @param dValue
	 * @return
	 */
	public String getNameByParentKeyAndDValue(String parentKey, Integer dValue) {
		System.out.println("   ======= : " + parentKey + "    " + dValue);
		Dictionary dictionary = new Dictionary();
		dictionary.setParentKey(parentKey);
		dictionary.setdValue(dValue.toString());
		Dictionary dict = dictionaryService.findByParentKeyAndValue(dictionary);
		return dict.getdName();
	}

	/**
	 * 获取字典name值
	 * 
	 * @param parentKey
	 *            字典key
	 * @return
	 */
	public String getName(String dKey) {
		if (StringUtils.isNotBlank(dKey)) {
			return dictionaryService.findBydKey(dKey).getdName();
		} else {
			return null;
		}
	}

	/**
	 * 获取字典value值
	 * 
	 * @param parentKey
	 *            字典key
	 * @return
	 */
	public List<Dictionary> getParentKey(String parentKey) {
		Dictionary dict = new Dictionary();
		dict.setParentKey(parentKey);
		return dictionaryService.findByParentKey(dict);
	}

	/**
	 * 获取字典value值
	 * 
	 * @param parentKey,dValue
	 *            字典key
	 * @return
	 */
	// public String getNameByParentAndValue(String parentKey,String dValue) {
	// if(StringUtils.isNotBlank(parentKey) && StringUtils.isNotBlank(dValue)) {
	// return dictionaryService.findByParentKeyAndValue(parentKey,
	// dValue).getdName();
	// }else {
	// return null;
	// }
	// }

}
