package com.up.mls.web.service;

import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.stereotype.Service;

import com.up.mls.mapper.system.MenuMapper;
import com.up.mls.util.SpringSecurityUtils;
import com.up.mls.util.StringUtils;

/**
 * js调用 thymeleaf 实现按钮权限可见性
 * 
 * @author j.x.j
 */
@Service("permission")
public class PermissionService {
	
	@Autowired
	private MenuMapper menuMapper;
	
	public String hasPermi(String permission) {
		return isPermittedOperator(permission) ? "" : "hidden";
	}

	private boolean isPermittedOperator(String permission) {

//		SecurityContextHolder.getContext().getAuthentication().getAuthorities();
//		return true;
//		boolean b = false;
//		List<SimpleGrantedAuthority> auths = menuMapper.selectMenusByUserId(SpringSecurityUtils.getUserId()).stream().filter(m->StringUtils.isNotBlank(m.getPerms()))
//				.map(m -> new SimpleGrantedAuthority(m.getPerms())).collect(Collectors.toList());
//		for(SimpleGrantedAuthority sga: auths) {
//			if(sga.getAuthority().equals(permission)) {
//				b = true;
//			}
//		}
//		return b;
		return true;
	}
	
	/**
	 * 为品牌模块 - 品牌显示城市临时添加  后期与上面方法合并
	 * @param permission
	 * @return
	 */
	public String hasPermiForBrand(String permission) {
		return isPerShow(permission) ? "" : "hidden";
	}
	
	public boolean isPerShow(String permission) {
		boolean b = false;
		List<SimpleGrantedAuthority> auths = menuMapper.selectMenusPermByUserId(SpringSecurityUtils.getUserId()).stream().filter(m->StringUtils.isNotBlank(m.getPerms()))
				.map(m -> new SimpleGrantedAuthority(m.getPerms())).collect(Collectors.toList());
		for(SimpleGrantedAuthority sga: auths) {
			if(sga.getAuthority().equals(permission)) {
				b = true;
			}
		}
		return b;
	}

}
