/// <reference path="../Extension/jquery-1.10.2.js" />
/// <reference path="../Extension/applicationCore.js" />

/*封装基本的http访问方法*/
var httpClientForUpAdmin = {
    layer: {},
    initLayer:function(){
		if(undefined != adminLayer) {
			httpClientForUpAdmin.layer = adminLayer;
			return;
		};
		httpClientForUpAdmin.layer = layer;
    },
    /*创建请求配置*/
    createConfig: function () {
        var instance = {
            fordwardUrl: null,
            type: null,
            data: null,
            defaultOk: null,
            defaultFail: null,
            callback: null
        };
        return instance;
    },

    checkConfig: function (url) {
        if (url == undefined || url.length <= 0) {
            return false;
        } else {
            return true;
        }
    },

    baseAction: function (config) {
        var index = httpClientForUpAdmin.layer.loading({});
        var options = {
            url: config.fordwardUrl,
            type: config.type,
            cache: false,
            dataType:'json',
            success: function (data) {
                if (config.callback != undefined) {
                    config.callback(data);
                } else {
                    if (data.Type == '200') {
                        if (config.defaultOk != undefined) {
                            httpClientForUpAdmin.layer.alert({ content: config.defaultOk });
                        }
                    }else if(data.Type == '403'){
                    		httpClientForUpAdmin.layer.alert({ content: '没有权限' });
                    }else {
                        if (config.defaultFail != undefined) {
                            httpClientForUpAdmin.layer.alert({ content: config.defaultFail });
                        }
                    }
                }
                httpClientForUpAdmin.layer.close(index);
            },
            error: function (a, b, c) {
                httpClientForUpAdmin.layer.alert({ content: "服务器报错，请联系管理员" });
                httpClientForUpAdmin.layer.close(index);
                if (config.callback != undefined) {
                    config.callback({Type:'500',XMLHttpRequest:a,textStatus:b,errorThrown:c});
                }
            }
        };
        if (config.data) {
            options.data = config.data;
            options.dataType = 'json';
        }
        $.ajax(options);
    },
    /*GET 请求*/
    get: function (url, paras, callback) {
        if (!httpClientForUpAdmin.checkConfig(url)) {
            httpClientForUpAdmin.layer.msg("参数有误，请检查您的参数");
            return;
        }
        //格式化 请求的url
        var config = httpClientForUpAdmin.createConfig();
        config.fordwardUrl = url;
        config.type = "GET";
        config.data = { Content: null };
        config.callback = callback;
        httpClientForUpAdmin.baseAction(config);
    },

    /*POST请求*/
    post: function (url, data, callback) {
        if (!httpClientForUpAdmin.checkConfig(url) || data == undefined) {
            httpClientForUpAdmin.layer.msg("参数有误，请检查您的参数");
            return;
        }
        var config = httpClientForUpAdmin.createConfig();
        config.fordwardUrl = url;
        config.type = "POST";
        config.data = data;
        config.defaultOk = "恭喜，添加成功";
        config.defaultFail = "抱歉，添加失败";
        config.callback = callback;
        httpClientForUpAdmin.baseAction(config);
    },

    del: function (url, paras, callback) {
        if (!httpClientForUpAdmin.checkConfig(url)) {
            httpClientForUpAdmin.layer.msg("参数有误，请检查您的参数");
            return;
        }
        //格式化  请求的url
        var config = httpClientForUpAdmin.createConfig();
        config.fordwardUrl = url;
        config.type = "POST";//为了兼容全部浏览器  请求类型使用post  不要使用兼容部分的delete协议
        //config.data = { Content: null};
        config.defaultOk = "恭喜，删除成功";
        config.defaultFail = "抱歉，删除失败";
        config.callback = callback;
        httpClientForUpAdmin.baseAction(config);
    },
    patch: function (url, data, callback) {
        if (!httpClientForUpAdmin.checkConfig(url) || data == undefined) {
            httpClientForUpAdmin.layer.msg("参数有误，请检查您的参数");
            return;
        }
        var config = httpClientForUpAdmin.createConfig();
        config.fordwardUrl = url;
        config.type = "POST";//为了兼容全部浏览器  请求类型使用post  不要使用兼容部分的Patch协议
        config.data = data;
        config.defaultOk = "恭喜，更新成功";
        config.defaultFail = "抱歉，更新失败";
        config.callback = callback;
        httpClientForUpAdmin.baseAction(config);
    }
}

/*字段验证器*/
var formValidator = {
    rules: {

    },
    fields: {

    },
    getEntity: function () {
        return $("form").serialize();
    },
    getActionUrl: function () {

    },
    init: function (url, callback) {
        $("form").validator({
            rules: formValidator.rules,
            fields: formValidator.fields,
            valid: function (form) {
                var me = this;
                me.holdSubmit();
                var entity = formValidator.getEntity();
                if (url === undefined || url === null || url.length <= 0)
                    url = formValidator.getActionUrl();
                		httpClientForUpAdmin.post(url, entity, function (data) {
                    me.holdSubmit(false);
                    callback(data);
                });
            }
        })
    },
	initSubmit:function(){
		$("form").validator({
            rules: formValidator.rules,
            fields: formValidator.fields,
            valid: function (form) {
                form.submit();
            }
        })
	}
}
httpClientForUpAdmin.initLayer();
